package net.minestom.server.item;

import java.util.function.Supplier;
import net.kyori.adventure.key.Key;
import net.kyori.adventure.key.Keyed;
import net.minestom.server.instance.block.Block;
import net.minestom.server.registry.Registries;
import net.minestom.server.utils.NamespaceID;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * AUTOGENERATED by MaterialGenerator
 */
public enum Material implements Keyed {
    AIR(NamespaceID.from("minecraft:air"), (byte) 64, () -> null),

    STONE(NamespaceID.from("minecraft:stone"), (byte) 64, () -> Registries.getBlock("minecraft:stone")),

    GRANITE(NamespaceID.from("minecraft:granite"), (byte) 64, () -> Registries.getBlock("minecraft:granite")),

    POLISHED_GRANITE(NamespaceID.from("minecraft:polished_granite"), (byte) 64, () -> Registries.getBlock("minecraft:polished_granite")),

    DIORITE(NamespaceID.from("minecraft:diorite"), (byte) 64, () -> Registries.getBlock("minecraft:diorite")),

    POLISHED_DIORITE(NamespaceID.from("minecraft:polished_diorite"), (byte) 64, () -> Registries.getBlock("minecraft:polished_diorite")),

    ANDESITE(NamespaceID.from("minecraft:andesite"), (byte) 64, () -> Registries.getBlock("minecraft:andesite")),

    POLISHED_ANDESITE(NamespaceID.from("minecraft:polished_andesite"), (byte) 64, () -> Registries.getBlock("minecraft:polished_andesite")),

    GRASS_BLOCK(NamespaceID.from("minecraft:grass_block"), (byte) 64, () -> Registries.getBlock("minecraft:grass_block")),

    DIRT(NamespaceID.from("minecraft:dirt"), (byte) 64, () -> Registries.getBlock("minecraft:dirt")),

    COARSE_DIRT(NamespaceID.from("minecraft:coarse_dirt"), (byte) 64, () -> Registries.getBlock("minecraft:coarse_dirt")),

    PODZOL(NamespaceID.from("minecraft:podzol"), (byte) 64, () -> Registries.getBlock("minecraft:podzol")),

    CRIMSON_NYLIUM(NamespaceID.from("minecraft:crimson_nylium"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_nylium")),

    WARPED_NYLIUM(NamespaceID.from("minecraft:warped_nylium"), (byte) 64, () -> Registries.getBlock("minecraft:warped_nylium")),

    COBBLESTONE(NamespaceID.from("minecraft:cobblestone"), (byte) 64, () -> Registries.getBlock("minecraft:cobblestone")),

    OAK_PLANKS(NamespaceID.from("minecraft:oak_planks"), (byte) 64, () -> Registries.getBlock("minecraft:oak_planks")),

    SPRUCE_PLANKS(NamespaceID.from("minecraft:spruce_planks"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_planks")),

    BIRCH_PLANKS(NamespaceID.from("minecraft:birch_planks"), (byte) 64, () -> Registries.getBlock("minecraft:birch_planks")),

    JUNGLE_PLANKS(NamespaceID.from("minecraft:jungle_planks"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_planks")),

    ACACIA_PLANKS(NamespaceID.from("minecraft:acacia_planks"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_planks")),

    DARK_OAK_PLANKS(NamespaceID.from("minecraft:dark_oak_planks"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_planks")),

    CRIMSON_PLANKS(NamespaceID.from("minecraft:crimson_planks"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_planks")),

    WARPED_PLANKS(NamespaceID.from("minecraft:warped_planks"), (byte) 64, () -> Registries.getBlock("minecraft:warped_planks")),

    OAK_SAPLING(NamespaceID.from("minecraft:oak_sapling"), (byte) 64, () -> Registries.getBlock("minecraft:oak_sapling")),

    SPRUCE_SAPLING(NamespaceID.from("minecraft:spruce_sapling"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_sapling")),

    BIRCH_SAPLING(NamespaceID.from("minecraft:birch_sapling"), (byte) 64, () -> Registries.getBlock("minecraft:birch_sapling")),

    JUNGLE_SAPLING(NamespaceID.from("minecraft:jungle_sapling"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_sapling")),

    ACACIA_SAPLING(NamespaceID.from("minecraft:acacia_sapling"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_sapling")),

    DARK_OAK_SAPLING(NamespaceID.from("minecraft:dark_oak_sapling"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_sapling")),

    BEDROCK(NamespaceID.from("minecraft:bedrock"), (byte) 64, () -> Registries.getBlock("minecraft:bedrock")),

    SAND(NamespaceID.from("minecraft:sand"), (byte) 64, () -> Registries.getBlock("minecraft:sand")),

    RED_SAND(NamespaceID.from("minecraft:red_sand"), (byte) 64, () -> Registries.getBlock("minecraft:red_sand")),

    GRAVEL(NamespaceID.from("minecraft:gravel"), (byte) 64, () -> Registries.getBlock("minecraft:gravel")),

    GOLD_ORE(NamespaceID.from("minecraft:gold_ore"), (byte) 64, () -> Registries.getBlock("minecraft:gold_ore")),

    IRON_ORE(NamespaceID.from("minecraft:iron_ore"), (byte) 64, () -> Registries.getBlock("minecraft:iron_ore")),

    COAL_ORE(NamespaceID.from("minecraft:coal_ore"), (byte) 64, () -> Registries.getBlock("minecraft:coal_ore")),

    NETHER_GOLD_ORE(NamespaceID.from("minecraft:nether_gold_ore"), (byte) 64, () -> Registries.getBlock("minecraft:nether_gold_ore")),

    OAK_LOG(NamespaceID.from("minecraft:oak_log"), (byte) 64, () -> Registries.getBlock("minecraft:oak_log")),

    SPRUCE_LOG(NamespaceID.from("minecraft:spruce_log"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_log")),

    BIRCH_LOG(NamespaceID.from("minecraft:birch_log"), (byte) 64, () -> Registries.getBlock("minecraft:birch_log")),

    JUNGLE_LOG(NamespaceID.from("minecraft:jungle_log"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_log")),

    ACACIA_LOG(NamespaceID.from("minecraft:acacia_log"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_log")),

    DARK_OAK_LOG(NamespaceID.from("minecraft:dark_oak_log"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_log")),

    CRIMSON_STEM(NamespaceID.from("minecraft:crimson_stem"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_stem")),

    WARPED_STEM(NamespaceID.from("minecraft:warped_stem"), (byte) 64, () -> Registries.getBlock("minecraft:warped_stem")),

    STRIPPED_OAK_LOG(NamespaceID.from("minecraft:stripped_oak_log"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_oak_log")),

    STRIPPED_SPRUCE_LOG(NamespaceID.from("minecraft:stripped_spruce_log"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_spruce_log")),

    STRIPPED_BIRCH_LOG(NamespaceID.from("minecraft:stripped_birch_log"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_birch_log")),

    STRIPPED_JUNGLE_LOG(NamespaceID.from("minecraft:stripped_jungle_log"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_jungle_log")),

    STRIPPED_ACACIA_LOG(NamespaceID.from("minecraft:stripped_acacia_log"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_acacia_log")),

    STRIPPED_DARK_OAK_LOG(NamespaceID.from("minecraft:stripped_dark_oak_log"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_dark_oak_log")),

    STRIPPED_CRIMSON_STEM(NamespaceID.from("minecraft:stripped_crimson_stem"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_crimson_stem")),

    STRIPPED_WARPED_STEM(NamespaceID.from("minecraft:stripped_warped_stem"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_warped_stem")),

    STRIPPED_OAK_WOOD(NamespaceID.from("minecraft:stripped_oak_wood"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_oak_wood")),

    STRIPPED_SPRUCE_WOOD(NamespaceID.from("minecraft:stripped_spruce_wood"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_spruce_wood")),

    STRIPPED_BIRCH_WOOD(NamespaceID.from("minecraft:stripped_birch_wood"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_birch_wood")),

    STRIPPED_JUNGLE_WOOD(NamespaceID.from("minecraft:stripped_jungle_wood"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_jungle_wood")),

    STRIPPED_ACACIA_WOOD(NamespaceID.from("minecraft:stripped_acacia_wood"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_acacia_wood")),

    STRIPPED_DARK_OAK_WOOD(NamespaceID.from("minecraft:stripped_dark_oak_wood"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_dark_oak_wood")),

    STRIPPED_CRIMSON_HYPHAE(NamespaceID.from("minecraft:stripped_crimson_hyphae"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_crimson_hyphae")),

    STRIPPED_WARPED_HYPHAE(NamespaceID.from("minecraft:stripped_warped_hyphae"), (byte) 64, () -> Registries.getBlock("minecraft:stripped_warped_hyphae")),

    OAK_WOOD(NamespaceID.from("minecraft:oak_wood"), (byte) 64, () -> Registries.getBlock("minecraft:oak_wood")),

    SPRUCE_WOOD(NamespaceID.from("minecraft:spruce_wood"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_wood")),

    BIRCH_WOOD(NamespaceID.from("minecraft:birch_wood"), (byte) 64, () -> Registries.getBlock("minecraft:birch_wood")),

    JUNGLE_WOOD(NamespaceID.from("minecraft:jungle_wood"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_wood")),

    ACACIA_WOOD(NamespaceID.from("minecraft:acacia_wood"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_wood")),

    DARK_OAK_WOOD(NamespaceID.from("minecraft:dark_oak_wood"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_wood")),

    CRIMSON_HYPHAE(NamespaceID.from("minecraft:crimson_hyphae"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_hyphae")),

    WARPED_HYPHAE(NamespaceID.from("minecraft:warped_hyphae"), (byte) 64, () -> Registries.getBlock("minecraft:warped_hyphae")),

    OAK_LEAVES(NamespaceID.from("minecraft:oak_leaves"), (byte) 64, () -> Registries.getBlock("minecraft:oak_leaves")),

    SPRUCE_LEAVES(NamespaceID.from("minecraft:spruce_leaves"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_leaves")),

    BIRCH_LEAVES(NamespaceID.from("minecraft:birch_leaves"), (byte) 64, () -> Registries.getBlock("minecraft:birch_leaves")),

    JUNGLE_LEAVES(NamespaceID.from("minecraft:jungle_leaves"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_leaves")),

    ACACIA_LEAVES(NamespaceID.from("minecraft:acacia_leaves"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_leaves")),

    DARK_OAK_LEAVES(NamespaceID.from("minecraft:dark_oak_leaves"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_leaves")),

    SPONGE(NamespaceID.from("minecraft:sponge"), (byte) 64, () -> Registries.getBlock("minecraft:sponge")),

    WET_SPONGE(NamespaceID.from("minecraft:wet_sponge"), (byte) 64, () -> Registries.getBlock("minecraft:wet_sponge")),

    GLASS(NamespaceID.from("minecraft:glass"), (byte) 64, () -> Registries.getBlock("minecraft:glass")),

    LAPIS_ORE(NamespaceID.from("minecraft:lapis_ore"), (byte) 64, () -> Registries.getBlock("minecraft:lapis_ore")),

    LAPIS_BLOCK(NamespaceID.from("minecraft:lapis_block"), (byte) 64, () -> Registries.getBlock("minecraft:lapis_block")),

    DISPENSER(NamespaceID.from("minecraft:dispenser"), (byte) 64, () -> Registries.getBlock("minecraft:dispenser")),

    SANDSTONE(NamespaceID.from("minecraft:sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:sandstone")),

    CHISELED_SANDSTONE(NamespaceID.from("minecraft:chiseled_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:chiseled_sandstone")),

    CUT_SANDSTONE(NamespaceID.from("minecraft:cut_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:cut_sandstone")),

    NOTE_BLOCK(NamespaceID.from("minecraft:note_block"), (byte) 64, () -> Registries.getBlock("minecraft:note_block")),

    POWERED_RAIL(NamespaceID.from("minecraft:powered_rail"), (byte) 64, () -> Registries.getBlock("minecraft:powered_rail")),

    DETECTOR_RAIL(NamespaceID.from("minecraft:detector_rail"), (byte) 64, () -> Registries.getBlock("minecraft:detector_rail")),

    STICKY_PISTON(NamespaceID.from("minecraft:sticky_piston"), (byte) 64, () -> Registries.getBlock("minecraft:sticky_piston")),

    COBWEB(NamespaceID.from("minecraft:cobweb"), (byte) 64, () -> Registries.getBlock("minecraft:cobweb")),

    GRASS(NamespaceID.from("minecraft:grass"), (byte) 64, () -> Registries.getBlock("minecraft:grass")),

    FERN(NamespaceID.from("minecraft:fern"), (byte) 64, () -> Registries.getBlock("minecraft:fern")),

    DEAD_BUSH(NamespaceID.from("minecraft:dead_bush"), (byte) 64, () -> Registries.getBlock("minecraft:dead_bush")),

    SEAGRASS(NamespaceID.from("minecraft:seagrass"), (byte) 64, () -> Registries.getBlock("minecraft:seagrass")),

    SEA_PICKLE(NamespaceID.from("minecraft:sea_pickle"), (byte) 64, () -> Registries.getBlock("minecraft:sea_pickle")),

    PISTON(NamespaceID.from("minecraft:piston"), (byte) 64, () -> Registries.getBlock("minecraft:piston")),

    WHITE_WOOL(NamespaceID.from("minecraft:white_wool"), (byte) 64, () -> Registries.getBlock("minecraft:white_wool")),

    ORANGE_WOOL(NamespaceID.from("minecraft:orange_wool"), (byte) 64, () -> Registries.getBlock("minecraft:orange_wool")),

    MAGENTA_WOOL(NamespaceID.from("minecraft:magenta_wool"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_wool")),

    LIGHT_BLUE_WOOL(NamespaceID.from("minecraft:light_blue_wool"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_wool")),

    YELLOW_WOOL(NamespaceID.from("minecraft:yellow_wool"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_wool")),

    LIME_WOOL(NamespaceID.from("minecraft:lime_wool"), (byte) 64, () -> Registries.getBlock("minecraft:lime_wool")),

    PINK_WOOL(NamespaceID.from("minecraft:pink_wool"), (byte) 64, () -> Registries.getBlock("minecraft:pink_wool")),

    GRAY_WOOL(NamespaceID.from("minecraft:gray_wool"), (byte) 64, () -> Registries.getBlock("minecraft:gray_wool")),

    LIGHT_GRAY_WOOL(NamespaceID.from("minecraft:light_gray_wool"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_wool")),

    CYAN_WOOL(NamespaceID.from("minecraft:cyan_wool"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_wool")),

    PURPLE_WOOL(NamespaceID.from("minecraft:purple_wool"), (byte) 64, () -> Registries.getBlock("minecraft:purple_wool")),

    BLUE_WOOL(NamespaceID.from("minecraft:blue_wool"), (byte) 64, () -> Registries.getBlock("minecraft:blue_wool")),

    BROWN_WOOL(NamespaceID.from("minecraft:brown_wool"), (byte) 64, () -> Registries.getBlock("minecraft:brown_wool")),

    GREEN_WOOL(NamespaceID.from("minecraft:green_wool"), (byte) 64, () -> Registries.getBlock("minecraft:green_wool")),

    RED_WOOL(NamespaceID.from("minecraft:red_wool"), (byte) 64, () -> Registries.getBlock("minecraft:red_wool")),

    BLACK_WOOL(NamespaceID.from("minecraft:black_wool"), (byte) 64, () -> Registries.getBlock("minecraft:black_wool")),

    DANDELION(NamespaceID.from("minecraft:dandelion"), (byte) 64, () -> Registries.getBlock("minecraft:dandelion")),

    POPPY(NamespaceID.from("minecraft:poppy"), (byte) 64, () -> Registries.getBlock("minecraft:poppy")),

    BLUE_ORCHID(NamespaceID.from("minecraft:blue_orchid"), (byte) 64, () -> Registries.getBlock("minecraft:blue_orchid")),

    ALLIUM(NamespaceID.from("minecraft:allium"), (byte) 64, () -> Registries.getBlock("minecraft:allium")),

    AZURE_BLUET(NamespaceID.from("minecraft:azure_bluet"), (byte) 64, () -> Registries.getBlock("minecraft:azure_bluet")),

    RED_TULIP(NamespaceID.from("minecraft:red_tulip"), (byte) 64, () -> Registries.getBlock("minecraft:red_tulip")),

    ORANGE_TULIP(NamespaceID.from("minecraft:orange_tulip"), (byte) 64, () -> Registries.getBlock("minecraft:orange_tulip")),

    WHITE_TULIP(NamespaceID.from("minecraft:white_tulip"), (byte) 64, () -> Registries.getBlock("minecraft:white_tulip")),

    PINK_TULIP(NamespaceID.from("minecraft:pink_tulip"), (byte) 64, () -> Registries.getBlock("minecraft:pink_tulip")),

    OXEYE_DAISY(NamespaceID.from("minecraft:oxeye_daisy"), (byte) 64, () -> Registries.getBlock("minecraft:oxeye_daisy")),

    CORNFLOWER(NamespaceID.from("minecraft:cornflower"), (byte) 64, () -> Registries.getBlock("minecraft:cornflower")),

    LILY_OF_THE_VALLEY(NamespaceID.from("minecraft:lily_of_the_valley"), (byte) 64, () -> Registries.getBlock("minecraft:lily_of_the_valley")),

    WITHER_ROSE(NamespaceID.from("minecraft:wither_rose"), (byte) 64, () -> Registries.getBlock("minecraft:wither_rose")),

    BROWN_MUSHROOM(NamespaceID.from("minecraft:brown_mushroom"), (byte) 64, () -> Registries.getBlock("minecraft:brown_mushroom")),

    RED_MUSHROOM(NamespaceID.from("minecraft:red_mushroom"), (byte) 64, () -> Registries.getBlock("minecraft:red_mushroom")),

    CRIMSON_FUNGUS(NamespaceID.from("minecraft:crimson_fungus"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_fungus")),

    WARPED_FUNGUS(NamespaceID.from("minecraft:warped_fungus"), (byte) 64, () -> Registries.getBlock("minecraft:warped_fungus")),

    CRIMSON_ROOTS(NamespaceID.from("minecraft:crimson_roots"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_roots")),

    WARPED_ROOTS(NamespaceID.from("minecraft:warped_roots"), (byte) 64, () -> Registries.getBlock("minecraft:warped_roots")),

    NETHER_SPROUTS(NamespaceID.from("minecraft:nether_sprouts"), (byte) 64, () -> Registries.getBlock("minecraft:nether_sprouts")),

    WEEPING_VINES(NamespaceID.from("minecraft:weeping_vines"), (byte) 64, () -> Registries.getBlock("minecraft:weeping_vines")),

    TWISTING_VINES(NamespaceID.from("minecraft:twisting_vines"), (byte) 64, () -> Registries.getBlock("minecraft:twisting_vines")),

    SUGAR_CANE(NamespaceID.from("minecraft:sugar_cane"), (byte) 64, () -> Registries.getBlock("minecraft:sugar_cane")),

    KELP(NamespaceID.from("minecraft:kelp"), (byte) 64, () -> Registries.getBlock("minecraft:kelp")),

    BAMBOO(NamespaceID.from("minecraft:bamboo"), (byte) 64, () -> Registries.getBlock("minecraft:bamboo")),

    GOLD_BLOCK(NamespaceID.from("minecraft:gold_block"), (byte) 64, () -> Registries.getBlock("minecraft:gold_block")),

    IRON_BLOCK(NamespaceID.from("minecraft:iron_block"), (byte) 64, () -> Registries.getBlock("minecraft:iron_block")),

    OAK_SLAB(NamespaceID.from("minecraft:oak_slab"), (byte) 64, () -> Registries.getBlock("minecraft:oak_slab")),

    SPRUCE_SLAB(NamespaceID.from("minecraft:spruce_slab"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_slab")),

    BIRCH_SLAB(NamespaceID.from("minecraft:birch_slab"), (byte) 64, () -> Registries.getBlock("minecraft:birch_slab")),

    JUNGLE_SLAB(NamespaceID.from("minecraft:jungle_slab"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_slab")),

    ACACIA_SLAB(NamespaceID.from("minecraft:acacia_slab"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_slab")),

    DARK_OAK_SLAB(NamespaceID.from("minecraft:dark_oak_slab"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_slab")),

    CRIMSON_SLAB(NamespaceID.from("minecraft:crimson_slab"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_slab")),

    WARPED_SLAB(NamespaceID.from("minecraft:warped_slab"), (byte) 64, () -> Registries.getBlock("minecraft:warped_slab")),

    STONE_SLAB(NamespaceID.from("minecraft:stone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:stone_slab")),

    SMOOTH_STONE_SLAB(NamespaceID.from("minecraft:smooth_stone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_stone_slab")),

    SANDSTONE_SLAB(NamespaceID.from("minecraft:sandstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:sandstone_slab")),

    CUT_STANDSTONE_SLAB(NamespaceID.from("minecraft:cut_sandstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:cut_sandstone_slab")),

    PETRIFIED_OAK_SLAB(NamespaceID.from("minecraft:petrified_oak_slab"), (byte) 64, () -> Registries.getBlock("minecraft:petrified_oak_slab")),

    COBBLESTONE_SLAB(NamespaceID.from("minecraft:cobblestone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:cobblestone_slab")),

    BRICK_SLAB(NamespaceID.from("minecraft:brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:brick_slab")),

    STONE_BRICK_SLAB(NamespaceID.from("minecraft:stone_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:stone_brick_slab")),

    NETHER_BRICK_SLAB(NamespaceID.from("minecraft:nether_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:nether_brick_slab")),

    QUARTZ_SLAB(NamespaceID.from("minecraft:quartz_slab"), (byte) 64, () -> Registries.getBlock("minecraft:quartz_slab")),

    RED_SANDSTONE_SLAB(NamespaceID.from("minecraft:red_sandstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:red_sandstone_slab")),

    CUT_RED_SANDSTONE_SLAB(NamespaceID.from("minecraft:cut_red_sandstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:cut_red_sandstone_slab")),

    PURPUR_SLAB(NamespaceID.from("minecraft:purpur_slab"), (byte) 64, () -> Registries.getBlock("minecraft:purpur_slab")),

    PRISMARINE_SLAB(NamespaceID.from("minecraft:prismarine_slab"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine_slab")),

    PRISMARINE_BRICK_SLAB(NamespaceID.from("minecraft:prismarine_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine_brick_slab")),

    DARK_PRISMARINE_SLAB(NamespaceID.from("minecraft:dark_prismarine_slab"), (byte) 64, () -> Registries.getBlock("minecraft:dark_prismarine_slab")),

    SMOOTH_QUARTZ(NamespaceID.from("minecraft:smooth_quartz"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_quartz")),

    SMOOTH_RED_SANDSTONE(NamespaceID.from("minecraft:smooth_red_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_red_sandstone")),

    SMOOTH_SANDSTONE(NamespaceID.from("minecraft:smooth_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_sandstone")),

    SMOOTH_STONE(NamespaceID.from("minecraft:smooth_stone"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_stone")),

    BRICKS(NamespaceID.from("minecraft:bricks"), (byte) 64, () -> Registries.getBlock("minecraft:bricks")),

    TNT(NamespaceID.from("minecraft:tnt"), (byte) 64, () -> Registries.getBlock("minecraft:tnt")),

    BOOKSHELF(NamespaceID.from("minecraft:bookshelf"), (byte) 64, () -> Registries.getBlock("minecraft:bookshelf")),

    MOSSY_COBBLESTONE(NamespaceID.from("minecraft:mossy_cobblestone"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_cobblestone")),

    OBSIDIAN(NamespaceID.from("minecraft:obsidian"), (byte) 64, () -> Registries.getBlock("minecraft:obsidian")),

    TORCH(NamespaceID.from("minecraft:torch"), (byte) 64, () -> Registries.getBlock("minecraft:torch")),

    END_ROD(NamespaceID.from("minecraft:end_rod"), (byte) 64, () -> Registries.getBlock("minecraft:end_rod")),

    CHORUS_PLANT(NamespaceID.from("minecraft:chorus_plant"), (byte) 64, () -> Registries.getBlock("minecraft:chorus_plant")),

    CHORUS_FLOWER(NamespaceID.from("minecraft:chorus_flower"), (byte) 64, () -> Registries.getBlock("minecraft:chorus_flower")),

    PURPUR_BLOCK(NamespaceID.from("minecraft:purpur_block"), (byte) 64, () -> Registries.getBlock("minecraft:purpur_block")),

    PURPUR_PILLAR(NamespaceID.from("minecraft:purpur_pillar"), (byte) 64, () -> Registries.getBlock("minecraft:purpur_pillar")),

    PURPUR_STAIRS(NamespaceID.from("minecraft:purpur_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:purpur_stairs")),

    SPAWNER(NamespaceID.from("minecraft:spawner"), (byte) 64, () -> Registries.getBlock("minecraft:spawner")),

    OAK_STAIRS(NamespaceID.from("minecraft:oak_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:oak_stairs")),

    CHEST(NamespaceID.from("minecraft:chest"), (byte) 64, () -> Registries.getBlock("minecraft:chest")),

    DIAMOND_ORE(NamespaceID.from("minecraft:diamond_ore"), (byte) 64, () -> Registries.getBlock("minecraft:diamond_ore")),

    DIAMOND_BLOCK(NamespaceID.from("minecraft:diamond_block"), (byte) 64, () -> Registries.getBlock("minecraft:diamond_block")),

    CRAFTING_TABLE(NamespaceID.from("minecraft:crafting_table"), (byte) 64, () -> Registries.getBlock("minecraft:crafting_table")),

    FARMLAND(NamespaceID.from("minecraft:farmland"), (byte) 64, () -> Registries.getBlock("minecraft:farmland")),

    FURNACE(NamespaceID.from("minecraft:furnace"), (byte) 64, () -> Registries.getBlock("minecraft:furnace")),

    LADDER(NamespaceID.from("minecraft:ladder"), (byte) 64, () -> Registries.getBlock("minecraft:ladder")),

    RAIL(NamespaceID.from("minecraft:rail"), (byte) 64, () -> Registries.getBlock("minecraft:rail")),

    COBBLESTONE_STAIRS(NamespaceID.from("minecraft:cobblestone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:cobblestone_stairs")),

    LEVER(NamespaceID.from("minecraft:lever"), (byte) 64, () -> Registries.getBlock("minecraft:lever")),

    STONE_PRESSURE_PLATE(NamespaceID.from("minecraft:stone_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:stone_pressure_plate")),

    OAK_PRESSURE_PLATE(NamespaceID.from("minecraft:oak_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:oak_pressure_plate")),

    SPRUCE_PRESSURE_PLATE(NamespaceID.from("minecraft:spruce_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_pressure_plate")),

    BIRCH_PRESSURE_PLATE(NamespaceID.from("minecraft:birch_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:birch_pressure_plate")),

    JUNGLE_PRESSURE_PLATE(NamespaceID.from("minecraft:jungle_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_pressure_plate")),

    ACACIA_PRESSURE_PLATE(NamespaceID.from("minecraft:acacia_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_pressure_plate")),

    DARK_OAK_PRESSURE_PLATE(NamespaceID.from("minecraft:dark_oak_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_pressure_plate")),

    CRIMSON_PRESSURE_PLATE(NamespaceID.from("minecraft:crimson_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_pressure_plate")),

    WARPED_PRESSURE_PLATE(NamespaceID.from("minecraft:warped_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:warped_pressure_plate")),

    POLISHED_BLACKSTONE_PRESSURE_PLATE(NamespaceID.from("minecraft:polished_blackstone_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_pressure_plate")),

    REDSTONE_ORE(NamespaceID.from("minecraft:redstone_ore"), (byte) 64, () -> Registries.getBlock("minecraft:redstone_ore")),

    REDSTONE_TORCH(NamespaceID.from("minecraft:redstone_torch"), (byte) 64, () -> Registries.getBlock("minecraft:redstone_torch")),

    SNOW(NamespaceID.from("minecraft:snow"), (byte) 64, () -> Registries.getBlock("minecraft:snow")),

    ICE(NamespaceID.from("minecraft:ice"), (byte) 64, () -> Registries.getBlock("minecraft:ice")),

    SNOW_BLOCK(NamespaceID.from("minecraft:snow_block"), (byte) 64, () -> Registries.getBlock("minecraft:snow_block")),

    CACTUS(NamespaceID.from("minecraft:cactus"), (byte) 64, () -> Registries.getBlock("minecraft:cactus")),

    CLAY(NamespaceID.from("minecraft:clay"), (byte) 64, () -> Registries.getBlock("minecraft:clay")),

    JUKEBOX(NamespaceID.from("minecraft:jukebox"), (byte) 64, () -> Registries.getBlock("minecraft:jukebox")),

    OAK_FENCE(NamespaceID.from("minecraft:oak_fence"), (byte) 64, () -> Registries.getBlock("minecraft:oak_fence")),

    SPRUCE_FENCE(NamespaceID.from("minecraft:spruce_fence"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_fence")),

    BIRCH_FENCE(NamespaceID.from("minecraft:birch_fence"), (byte) 64, () -> Registries.getBlock("minecraft:birch_fence")),

    JUNGLE_FENCE(NamespaceID.from("minecraft:jungle_fence"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_fence")),

    ACACIA_FENCE(NamespaceID.from("minecraft:acacia_fence"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_fence")),

    DARK_OAK_FENCE(NamespaceID.from("minecraft:dark_oak_fence"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_fence")),

    CRIMSON_FENCE(NamespaceID.from("minecraft:crimson_fence"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_fence")),

    WARPED_FENCE(NamespaceID.from("minecraft:warped_fence"), (byte) 64, () -> Registries.getBlock("minecraft:warped_fence")),

    PUMPKIN(NamespaceID.from("minecraft:pumpkin"), (byte) 64, () -> Registries.getBlock("minecraft:pumpkin")),

    CARVED_PUMPKIN(NamespaceID.from("minecraft:carved_pumpkin"), (byte) 64, () -> Registries.getBlock("minecraft:carved_pumpkin")),

    NETHERRACK(NamespaceID.from("minecraft:netherrack"), (byte) 64, () -> Registries.getBlock("minecraft:netherrack")),

    SOUL_SAND(NamespaceID.from("minecraft:soul_sand"), (byte) 64, () -> Registries.getBlock("minecraft:soul_sand")),

    SOUL_SOIL(NamespaceID.from("minecraft:soul_soil"), (byte) 64, () -> Registries.getBlock("minecraft:soul_soil")),

    BASALT(NamespaceID.from("minecraft:basalt"), (byte) 64, () -> Registries.getBlock("minecraft:basalt")),

    POLISHED_BASALT(NamespaceID.from("minecraft:polished_basalt"), (byte) 64, () -> Registries.getBlock("minecraft:polished_basalt")),

    SOUL_TORCH(NamespaceID.from("minecraft:soul_torch"), (byte) 64, () -> Registries.getBlock("minecraft:soul_torch")),

    GLOWSTONE(NamespaceID.from("minecraft:glowstone"), (byte) 64, () -> Registries.getBlock("minecraft:glowstone")),

    JACK_O_LANTERN(NamespaceID.from("minecraft:jack_o_lantern"), (byte) 64, () -> Registries.getBlock("minecraft:jack_o_lantern")),

    OAK_TRAPDOOR(NamespaceID.from("minecraft:oak_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:oak_trapdoor")),

    SPRUCE_TRAPDOOR(NamespaceID.from("minecraft:spruce_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_trapdoor")),

    BIRCH_TRAPDOOR(NamespaceID.from("minecraft:birch_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:birch_trapdoor")),

    JUNGLE_TRAPDOOR(NamespaceID.from("minecraft:jungle_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_trapdoor")),

    ACACIA_TRAPDOOR(NamespaceID.from("minecraft:acacia_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_trapdoor")),

    DARK_OAK_TRAPDOOR(NamespaceID.from("minecraft:dark_oak_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_trapdoor")),

    CRIMSON_TRAPDOOR(NamespaceID.from("minecraft:crimson_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_trapdoor")),

    WARPED_TRAPDOOR(NamespaceID.from("minecraft:warped_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:warped_trapdoor")),

    INFESTED_STONE(NamespaceID.from("minecraft:infested_stone"), (byte) 64, () -> Registries.getBlock("minecraft:infested_stone")),

    INFESTED_COBBLESTONE(NamespaceID.from("minecraft:infested_cobblestone"), (byte) 64, () -> Registries.getBlock("minecraft:infested_cobblestone")),

    INFESTED_STONE_BRICKS(NamespaceID.from("minecraft:infested_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:infested_stone_bricks")),

    INFESTED_MOSSY_STONE_BRICKS(NamespaceID.from("minecraft:infested_mossy_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:infested_mossy_stone_bricks")),

    INFESTED_CRACKED_STONE_BRICKS(NamespaceID.from("minecraft:infested_cracked_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:infested_cracked_stone_bricks")),

    INFESTED_CHISELED_STONE_BRICKS(NamespaceID.from("minecraft:infested_chiseled_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:infested_chiseled_stone_bricks")),

    STONE_BRICKS(NamespaceID.from("minecraft:stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:stone_bricks")),

    MOSSY_STONE_BRICKS(NamespaceID.from("minecraft:mossy_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_stone_bricks")),

    CRACKED_STONE_BRICKS(NamespaceID.from("minecraft:cracked_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:cracked_stone_bricks")),

    CHISELED_STONE_BRICKS(NamespaceID.from("minecraft:chiseled_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:chiseled_stone_bricks")),

    BROWN_MUSHROOM_BLOCK(NamespaceID.from("minecraft:brown_mushroom_block"), (byte) 64, () -> Registries.getBlock("minecraft:brown_mushroom_block")),

    RED_MUSHROOM_BLOCK(NamespaceID.from("minecraft:red_mushroom_block"), (byte) 64, () -> Registries.getBlock("minecraft:red_mushroom_block")),

    MUSHROOM_STEM(NamespaceID.from("minecraft:mushroom_stem"), (byte) 64, () -> Registries.getBlock("minecraft:mushroom_stem")),

    IRON_BARS(NamespaceID.from("minecraft:iron_bars"), (byte) 64, () -> Registries.getBlock("minecraft:iron_bars")),

    CHAIN(NamespaceID.from("minecraft:chain"), (byte) 64, () -> Registries.getBlock("minecraft:chain")),

    GLASS_PANE(NamespaceID.from("minecraft:glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:glass_pane")),

    MELON(NamespaceID.from("minecraft:melon"), (byte) 64, () -> Registries.getBlock("minecraft:melon")),

    VINE(NamespaceID.from("minecraft:vine"), (byte) 64, () -> Registries.getBlock("minecraft:vine")),

    OAK_FENCE_GATE(NamespaceID.from("minecraft:oak_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:oak_fence_gate")),

    SPRUCE_FENCE_GATE(NamespaceID.from("minecraft:spruce_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_fence_gate")),

    BIRCH_FENCE_GATE(NamespaceID.from("minecraft:birch_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:birch_fence_gate")),

    JUNGLE_FENCE_GATE(NamespaceID.from("minecraft:jungle_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_fence_gate")),

    ACACIA_FENCE_GATE(NamespaceID.from("minecraft:acacia_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_fence_gate")),

    DARK_OAK_FENCE_GATE(NamespaceID.from("minecraft:dark_oak_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_fence_gate")),

    CRIMSON_FENCE_GATE(NamespaceID.from("minecraft:crimson_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_fence_gate")),

    WARPED_FENCE_GATE(NamespaceID.from("minecraft:warped_fence_gate"), (byte) 64, () -> Registries.getBlock("minecraft:warped_fence_gate")),

    BRICK_STAIRS(NamespaceID.from("minecraft:brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:brick_stairs")),

    STONE_BRICK_STAIRS(NamespaceID.from("minecraft:stone_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:stone_brick_stairs")),

    MYCELIUM(NamespaceID.from("minecraft:mycelium"), (byte) 64, () -> Registries.getBlock("minecraft:mycelium")),

    LILY_PAD(NamespaceID.from("minecraft:lily_pad"), (byte) 64, () -> Registries.getBlock("minecraft:lily_pad")),

    NETHER_BRICKS(NamespaceID.from("minecraft:nether_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:nether_bricks")),

    CRACKED_NETHER_BRICKS(NamespaceID.from("minecraft:cracked_nether_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:cracked_nether_bricks")),

    CHISELED_NETHER_BRICKS(NamespaceID.from("minecraft:chiseled_nether_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:chiseled_nether_bricks")),

    NETHER_BRICK_FENCE(NamespaceID.from("minecraft:nether_brick_fence"), (byte) 64, () -> Registries.getBlock("minecraft:nether_brick_fence")),

    NETHER_BRICK_STAIRS(NamespaceID.from("minecraft:nether_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:nether_brick_stairs")),

    ENCHANTING_TABLE(NamespaceID.from("minecraft:enchanting_table"), (byte) 64, () -> Registries.getBlock("minecraft:enchanting_table")),

    END_PORTAL_FRAME(NamespaceID.from("minecraft:end_portal_frame"), (byte) 64, () -> Registries.getBlock("minecraft:end_portal_frame")),

    END_STONE(NamespaceID.from("minecraft:end_stone"), (byte) 64, () -> Registries.getBlock("minecraft:end_stone")),

    END_STONE_BRICKS(NamespaceID.from("minecraft:end_stone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:end_stone_bricks")),

    DRAGON_EGG(NamespaceID.from("minecraft:dragon_egg"), (byte) 64, () -> Registries.getBlock("minecraft:dragon_egg")),

    REDSTONE_LAMP(NamespaceID.from("minecraft:redstone_lamp"), (byte) 64, () -> Registries.getBlock("minecraft:redstone_lamp")),

    SANDSTONE_STAIRS(NamespaceID.from("minecraft:sandstone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:sandstone_stairs")),

    EMERALD_ORE(NamespaceID.from("minecraft:emerald_ore"), (byte) 64, () -> Registries.getBlock("minecraft:emerald_ore")),

    ENDER_CHEST(NamespaceID.from("minecraft:ender_chest"), (byte) 64, () -> Registries.getBlock("minecraft:ender_chest")),

    TRIPWIRE_HOOK(NamespaceID.from("minecraft:tripwire_hook"), (byte) 64, () -> Registries.getBlock("minecraft:tripwire_hook")),

    EMERALD_BLOCK(NamespaceID.from("minecraft:emerald_block"), (byte) 64, () -> Registries.getBlock("minecraft:emerald_block")),

    SPRUCE_STAIRS(NamespaceID.from("minecraft:spruce_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_stairs")),

    BIRCH_STAIRS(NamespaceID.from("minecraft:birch_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:birch_stairs")),

    JUNGLE_STAIRS(NamespaceID.from("minecraft:jungle_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_stairs")),

    CRIMSON_STAIRS(NamespaceID.from("minecraft:crimson_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_stairs")),

    WARPED_STAIRS(NamespaceID.from("minecraft:warped_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:warped_stairs")),

    COMMAND_BLOCK(NamespaceID.from("minecraft:command_block"), (byte) 64, () -> Registries.getBlock("minecraft:command_block")),

    BEACON(NamespaceID.from("minecraft:beacon"), (byte) 64, () -> Registries.getBlock("minecraft:beacon")),

    COBBLESTONE_WALL(NamespaceID.from("minecraft:cobblestone_wall"), (byte) 64, () -> Registries.getBlock("minecraft:cobblestone_wall")),

    MOSSY_COBBLESTONE_WALL(NamespaceID.from("minecraft:mossy_cobblestone_wall"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_cobblestone_wall")),

    BRICK_WALL(NamespaceID.from("minecraft:brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:brick_wall")),

    PRISMARINE_WALL(NamespaceID.from("minecraft:prismarine_wall"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine_wall")),

    RED_SANDSTONE_WALL(NamespaceID.from("minecraft:red_sandstone_wall"), (byte) 64, () -> Registries.getBlock("minecraft:red_sandstone_wall")),

    MOSSY_STONE_BRICK_WALL(NamespaceID.from("minecraft:mossy_stone_brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_stone_brick_wall")),

    GRANITE_WALL(NamespaceID.from("minecraft:granite_wall"), (byte) 64, () -> Registries.getBlock("minecraft:granite_wall")),

    STONE_BRICK_WALL(NamespaceID.from("minecraft:stone_brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:stone_brick_wall")),

    NETHER_BRICK_WALL(NamespaceID.from("minecraft:nether_brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:nether_brick_wall")),

    ANDESITE_WALL(NamespaceID.from("minecraft:andesite_wall"), (byte) 64, () -> Registries.getBlock("minecraft:andesite_wall")),

    RED_NETHER_BRICK_WALL(NamespaceID.from("minecraft:red_nether_brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:red_nether_brick_wall")),

    SANDSTONE_WALL(NamespaceID.from("minecraft:sandstone_wall"), (byte) 64, () -> Registries.getBlock("minecraft:sandstone_wall")),

    END_STONE_BRICK_WALL(NamespaceID.from("minecraft:end_stone_brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:end_stone_brick_wall")),

    DIORITE_WALL(NamespaceID.from("minecraft:diorite_wall"), (byte) 64, () -> Registries.getBlock("minecraft:diorite_wall")),

    BLACKSTONE_WALL(NamespaceID.from("minecraft:blackstone_wall"), (byte) 64, () -> Registries.getBlock("minecraft:blackstone_wall")),

    POLISHED_BLACKSTONE_WALL(NamespaceID.from("minecraft:polished_blackstone_wall"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_wall")),

    POLISHED_BLACKSTONE_BRICK_WALL(NamespaceID.from("minecraft:polished_blackstone_brick_wall"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_brick_wall")),

    STONE_BUTTON(NamespaceID.from("minecraft:stone_button"), (byte) 64, () -> Registries.getBlock("minecraft:stone_button")),

    OAK_BUTTON(NamespaceID.from("minecraft:oak_button"), (byte) 64, () -> Registries.getBlock("minecraft:oak_button")),

    SPRUCE_BUTTON(NamespaceID.from("minecraft:spruce_button"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_button")),

    BIRCH_BUTTON(NamespaceID.from("minecraft:birch_button"), (byte) 64, () -> Registries.getBlock("minecraft:birch_button")),

    JUNGLE_BUTTON(NamespaceID.from("minecraft:jungle_button"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_button")),

    ACACIA_BUTTON(NamespaceID.from("minecraft:acacia_button"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_button")),

    DARK_OAK_BUTTON(NamespaceID.from("minecraft:dark_oak_button"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_button")),

    CRIMSON_BUTTON(NamespaceID.from("minecraft:crimson_button"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_button")),

    WARPED_BUTTON(NamespaceID.from("minecraft:warped_button"), (byte) 64, () -> Registries.getBlock("minecraft:warped_button")),

    POLISHED_BLACKSTONE_BUTTON(NamespaceID.from("minecraft:polished_blackstone_button"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_button")),

    ANVIL(NamespaceID.from("minecraft:anvil"), (byte) 64, () -> Registries.getBlock("minecraft:anvil")),

    CHIPPED_ANVIL(NamespaceID.from("minecraft:chipped_anvil"), (byte) 64, () -> Registries.getBlock("minecraft:chipped_anvil")),

    DAMAGED_ANVIL(NamespaceID.from("minecraft:damaged_anvil"), (byte) 64, () -> Registries.getBlock("minecraft:damaged_anvil")),

    TRAPPED_CHEST(NamespaceID.from("minecraft:trapped_chest"), (byte) 64, () -> Registries.getBlock("minecraft:trapped_chest")),

    LIGHT_WEIGHTED_PRESSURE_PLATE(NamespaceID.from("minecraft:light_weighted_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:light_weighted_pressure_plate")),

    HEAVY_WEIGHTED_PRESSURE_PLATE(NamespaceID.from("minecraft:heavy_weighted_pressure_plate"), (byte) 64, () -> Registries.getBlock("minecraft:heavy_weighted_pressure_plate")),

    DAYLIGHT_DETECTOR(NamespaceID.from("minecraft:daylight_detector"), (byte) 64, () -> Registries.getBlock("minecraft:daylight_detector")),

    REDSTONE_BLOCK(NamespaceID.from("minecraft:redstone_block"), (byte) 64, () -> Registries.getBlock("minecraft:redstone_block")),

    NETHER_QUARTZ_ORE(NamespaceID.from("minecraft:nether_quartz_ore"), (byte) 64, () -> Registries.getBlock("minecraft:nether_quartz_ore")),

    HOPPER(NamespaceID.from("minecraft:hopper"), (byte) 64, () -> Registries.getBlock("minecraft:hopper")),

    CHISELED_QUARTZ_BLOCK(NamespaceID.from("minecraft:chiseled_quartz_block"), (byte) 64, () -> Registries.getBlock("minecraft:chiseled_quartz_block")),

    QUARTZ_BLOCK(NamespaceID.from("minecraft:quartz_block"), (byte) 64, () -> Registries.getBlock("minecraft:quartz_block")),

    QUARTZ_BRICKS(NamespaceID.from("minecraft:quartz_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:quartz_bricks")),

    QUARTZ_PILLAR(NamespaceID.from("minecraft:quartz_pillar"), (byte) 64, () -> Registries.getBlock("minecraft:quartz_pillar")),

    QUARTZ_STAIRS(NamespaceID.from("minecraft:quartz_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:quartz_stairs")),

    ACTIVATOR_RAIL(NamespaceID.from("minecraft:activator_rail"), (byte) 64, () -> Registries.getBlock("minecraft:activator_rail")),

    DROPPER(NamespaceID.from("minecraft:dropper"), (byte) 64, () -> Registries.getBlock("minecraft:dropper")),

    WHITE_TERRACOTTA(NamespaceID.from("minecraft:white_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:white_terracotta")),

    ORANGE_TERRACOTTA(NamespaceID.from("minecraft:orange_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:orange_terracotta")),

    MAGENTA_TERRACOTTA(NamespaceID.from("minecraft:magenta_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_terracotta")),

    LIGHT_BLUE_TERRACOTTA(NamespaceID.from("minecraft:light_blue_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_terracotta")),

    YELLOW_TERRACOTTA(NamespaceID.from("minecraft:yellow_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_terracotta")),

    LIME_TERRACOTTA(NamespaceID.from("minecraft:lime_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:lime_terracotta")),

    PINK_TERRACOTTA(NamespaceID.from("minecraft:pink_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:pink_terracotta")),

    GRAY_TERRACOTTA(NamespaceID.from("minecraft:gray_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:gray_terracotta")),

    LIGHT_GRAY_TERRACOTTA(NamespaceID.from("minecraft:light_gray_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_terracotta")),

    CYAN_TERRACOTTA(NamespaceID.from("minecraft:cyan_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_terracotta")),

    PURPLE_TERRACOTTA(NamespaceID.from("minecraft:purple_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:purple_terracotta")),

    BLUE_TERRACOTTA(NamespaceID.from("minecraft:blue_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:blue_terracotta")),

    BROWN_TERRACOTTA(NamespaceID.from("minecraft:brown_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:brown_terracotta")),

    GREEN_TERRACOTTA(NamespaceID.from("minecraft:green_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:green_terracotta")),

    RED_TERRACOTTA(NamespaceID.from("minecraft:red_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:red_terracotta")),

    BLACK_TERRACOTTA(NamespaceID.from("minecraft:black_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:black_terracotta")),

    BARRIER(NamespaceID.from("minecraft:barrier"), (byte) 64, () -> Registries.getBlock("minecraft:barrier")),

    IRON_TRAPDOOR(NamespaceID.from("minecraft:iron_trapdoor"), (byte) 64, () -> Registries.getBlock("minecraft:iron_trapdoor")),

    HAY_BLOCK(NamespaceID.from("minecraft:hay_block"), (byte) 64, () -> Registries.getBlock("minecraft:hay_block")),

    WHITE_CARPET(NamespaceID.from("minecraft:white_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:white_carpet")),

    ORANGE_CARPET(NamespaceID.from("minecraft:orange_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:orange_carpet")),

    MAGENTA_CARPET(NamespaceID.from("minecraft:magenta_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_carpet")),

    LIGHT_BLUE_CARPET(NamespaceID.from("minecraft:light_blue_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_carpet")),

    YELLOW_CARPET(NamespaceID.from("minecraft:yellow_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_carpet")),

    LIME_CARPET(NamespaceID.from("minecraft:lime_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:lime_carpet")),

    PINK_CARPET(NamespaceID.from("minecraft:pink_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:pink_carpet")),

    GRAY_CARPET(NamespaceID.from("minecraft:gray_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:gray_carpet")),

    LIGHT_GRAY_CARPET(NamespaceID.from("minecraft:light_gray_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_carpet")),

    CYAN_CARPET(NamespaceID.from("minecraft:cyan_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_carpet")),

    PURPLE_CARPET(NamespaceID.from("minecraft:purple_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:purple_carpet")),

    BLUE_CARPET(NamespaceID.from("minecraft:blue_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:blue_carpet")),

    BROWN_CARPET(NamespaceID.from("minecraft:brown_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:brown_carpet")),

    GREEN_CARPET(NamespaceID.from("minecraft:green_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:green_carpet")),

    RED_CARPET(NamespaceID.from("minecraft:red_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:red_carpet")),

    BLACK_CARPET(NamespaceID.from("minecraft:black_carpet"), (byte) 64, () -> Registries.getBlock("minecraft:black_carpet")),

    TERRACOTTA(NamespaceID.from("minecraft:terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:terracotta")),

    COAL_BLOCK(NamespaceID.from("minecraft:coal_block"), (byte) 64, () -> Registries.getBlock("minecraft:coal_block")),

    PACKED_ICE(NamespaceID.from("minecraft:packed_ice"), (byte) 64, () -> Registries.getBlock("minecraft:packed_ice")),

    ACACIA_STAIRS(NamespaceID.from("minecraft:acacia_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_stairs")),

    DARK_OAK_STAIRS(NamespaceID.from("minecraft:dark_oak_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_stairs")),

    SLIME_BLOCK(NamespaceID.from("minecraft:slime_block"), (byte) 64, () -> Registries.getBlock("minecraft:slime_block")),

    GRASS_PATH(NamespaceID.from("minecraft:grass_path"), (byte) 64, () -> Registries.getBlock("minecraft:grass_path")),

    SUNFLOWER(NamespaceID.from("minecraft:sunflower"), (byte) 64, () -> Registries.getBlock("minecraft:sunflower")),

    LILAC(NamespaceID.from("minecraft:lilac"), (byte) 64, () -> Registries.getBlock("minecraft:lilac")),

    ROSE_BUSH(NamespaceID.from("minecraft:rose_bush"), (byte) 64, () -> Registries.getBlock("minecraft:rose_bush")),

    PEONY(NamespaceID.from("minecraft:peony"), (byte) 64, () -> Registries.getBlock("minecraft:peony")),

    TALL_GRASS(NamespaceID.from("minecraft:tall_grass"), (byte) 64, () -> Registries.getBlock("minecraft:tall_grass")),

    LARGE_FERN(NamespaceID.from("minecraft:large_fern"), (byte) 64, () -> Registries.getBlock("minecraft:large_fern")),

    WHITE_STAINED_GLASS(NamespaceID.from("minecraft:white_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:white_stained_glass")),

    ORANGE_STAINED_GLASS(NamespaceID.from("minecraft:orange_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:orange_stained_glass")),

    MAGENTA_STAINED_GLASS(NamespaceID.from("minecraft:magenta_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_stained_glass")),

    LIGHT_BLUE_STAINED_GLASS(NamespaceID.from("minecraft:light_blue_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_stained_glass")),

    YELLOW_STAINED_GLASS(NamespaceID.from("minecraft:yellow_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_stained_glass")),

    LIME_STAINED_GLASS(NamespaceID.from("minecraft:lime_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:lime_stained_glass")),

    PINK_STAINED_GLASS(NamespaceID.from("minecraft:pink_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:pink_stained_glass")),

    GRAY_STAINED_GLASS(NamespaceID.from("minecraft:gray_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:gray_stained_glass")),

    LIGHT_GRAY_STAINED_GLASS(NamespaceID.from("minecraft:light_gray_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_stained_glass")),

    CYAN_STAINED_GLASS(NamespaceID.from("minecraft:cyan_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_stained_glass")),

    PURPLE_STAINED_GLASS(NamespaceID.from("minecraft:purple_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:purple_stained_glass")),

    BLUE_STAINED_GLASS(NamespaceID.from("minecraft:blue_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:blue_stained_glass")),

    BROWN_STAINED_GLASS(NamespaceID.from("minecraft:brown_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:brown_stained_glass")),

    GREEN_STAINED_GLASS(NamespaceID.from("minecraft:green_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:green_stained_glass")),

    RED_STAINED_GLASS(NamespaceID.from("minecraft:red_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:red_stained_glass")),

    BLACK_STAINED_GLASS(NamespaceID.from("minecraft:black_stained_glass"), (byte) 64, () -> Registries.getBlock("minecraft:black_stained_glass")),

    WHITE_STAINED_GLASS_PANE(NamespaceID.from("minecraft:white_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:white_stained_glass_pane")),

    ORANGE_STAINED_GLASS_PANE(NamespaceID.from("minecraft:orange_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:orange_stained_glass_pane")),

    MAGENTA_STAINED_GLASS_PANE(NamespaceID.from("minecraft:magenta_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_stained_glass_pane")),

    LIGHT_BLUE_STAINED_GLASS_PANE(NamespaceID.from("minecraft:light_blue_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_stained_glass_pane")),

    YELLOW_STAINED_GLASS_PANE(NamespaceID.from("minecraft:yellow_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_stained_glass_pane")),

    LIME_STAINED_GLASS_PANE(NamespaceID.from("minecraft:lime_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:lime_stained_glass_pane")),

    PINK_STAINED_GLASS_PANE(NamespaceID.from("minecraft:pink_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:pink_stained_glass_pane")),

    GRAY_STAINED_GLASS_PANE(NamespaceID.from("minecraft:gray_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:gray_stained_glass_pane")),

    LIGHT_GRAY_STAINED_GLASS_PANE(NamespaceID.from("minecraft:light_gray_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_stained_glass_pane")),

    CYAN_STAINED_GLASS_PANE(NamespaceID.from("minecraft:cyan_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_stained_glass_pane")),

    PURPLE_STAINED_GLASS_PANE(NamespaceID.from("minecraft:purple_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:purple_stained_glass_pane")),

    BLUE_STAINED_GLASS_PANE(NamespaceID.from("minecraft:blue_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:blue_stained_glass_pane")),

    BROWN_STAINED_GLASS_PANE(NamespaceID.from("minecraft:brown_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:brown_stained_glass_pane")),

    GREEN_STAINED_GLASS_PANE(NamespaceID.from("minecraft:green_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:green_stained_glass_pane")),

    RED_STAINED_GLASS_PANE(NamespaceID.from("minecraft:red_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:red_stained_glass_pane")),

    BLACK_STAINED_GLASS_PANE(NamespaceID.from("minecraft:black_stained_glass_pane"), (byte) 64, () -> Registries.getBlock("minecraft:black_stained_glass_pane")),

    PRISMARINE(NamespaceID.from("minecraft:prismarine"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine")),

    PRISMARINE_BRICKS(NamespaceID.from("minecraft:prismarine_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine_bricks")),

    DARK_PRISMARINE(NamespaceID.from("minecraft:dark_prismarine"), (byte) 64, () -> Registries.getBlock("minecraft:dark_prismarine")),

    PRISMARINE_STAIRS(NamespaceID.from("minecraft:prismarine_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine_stairs")),

    PRISMARINE_BRICK_STAIRS(NamespaceID.from("minecraft:prismarine_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:prismarine_brick_stairs")),

    DARK_PRISMARINE_STAIRS(NamespaceID.from("minecraft:dark_prismarine_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:dark_prismarine_stairs")),

    SEA_LANTERN(NamespaceID.from("minecraft:sea_lantern"), (byte) 64, () -> Registries.getBlock("minecraft:sea_lantern")),

    RED_SANDSTONE(NamespaceID.from("minecraft:red_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:red_sandstone")),

    CHISELED_RED_SANDSTONE(NamespaceID.from("minecraft:chiseled_red_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:chiseled_red_sandstone")),

    CUT_RED_SANDSTONE(NamespaceID.from("minecraft:cut_red_sandstone"), (byte) 64, () -> Registries.getBlock("minecraft:cut_red_sandstone")),

    RED_SANDSTONE_STAIRS(NamespaceID.from("minecraft:red_sandstone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:red_sandstone_stairs")),

    REPEATING_COMMAND_BLOCK(NamespaceID.from("minecraft:repeating_command_block"), (byte) 64, () -> Registries.getBlock("minecraft:repeating_command_block")),

    CHAIN_COMMAND_BLOCK(NamespaceID.from("minecraft:chain_command_block"), (byte) 64, () -> Registries.getBlock("minecraft:chain_command_block")),

    MAGMA_BLOCK(NamespaceID.from("minecraft:magma_block"), (byte) 64, () -> Registries.getBlock("minecraft:magma_block")),

    NETHER_WART_BLOCK(NamespaceID.from("minecraft:nether_wart_block"), (byte) 64, () -> Registries.getBlock("minecraft:nether_wart_block")),

    WARPED_WART_BLOCK(NamespaceID.from("minecraft:warped_wart_block"), (byte) 64, () -> Registries.getBlock("minecraft:warped_wart_block")),

    RED_NETHER_BRICKS(NamespaceID.from("minecraft:red_nether_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:red_nether_bricks")),

    BONE_BLOCK(NamespaceID.from("minecraft:bone_block"), (byte) 64, () -> Registries.getBlock("minecraft:bone_block")),

    STRUCTURE_VOID(NamespaceID.from("minecraft:structure_void"), (byte) 64, () -> Registries.getBlock("minecraft:structure_void")),

    OBSERVER(NamespaceID.from("minecraft:observer"), (byte) 64, () -> Registries.getBlock("minecraft:observer")),

    SHULKER_BOX(NamespaceID.from("minecraft:shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:shulker_box")),

    WHITE_SHULKER_BOX(NamespaceID.from("minecraft:white_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:white_shulker_box")),

    ORANGE_SHULKER_BOX(NamespaceID.from("minecraft:orange_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:orange_shulker_box")),

    MAGENTA_SHULKER_BOX(NamespaceID.from("minecraft:magenta_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:magenta_shulker_box")),

    LIGHT_BLUE_SHULKER_BOX(NamespaceID.from("minecraft:light_blue_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:light_blue_shulker_box")),

    YELLOW_SHULKER_BOX(NamespaceID.from("minecraft:yellow_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:yellow_shulker_box")),

    LIME_SHULKER_BOX(NamespaceID.from("minecraft:lime_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:lime_shulker_box")),

    PINK_SHULKER_BOX(NamespaceID.from("minecraft:pink_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:pink_shulker_box")),

    GRAY_SHULKER_BOX(NamespaceID.from("minecraft:gray_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:gray_shulker_box")),

    LIGHT_GRAY_SHULKER_BOX(NamespaceID.from("minecraft:light_gray_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:light_gray_shulker_box")),

    CYAN_SHULKER_BOX(NamespaceID.from("minecraft:cyan_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:cyan_shulker_box")),

    PURPLE_SHULKER_BOX(NamespaceID.from("minecraft:purple_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:purple_shulker_box")),

    BLUE_SHULKER_BOX(NamespaceID.from("minecraft:blue_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:blue_shulker_box")),

    BROWN_SHULKER_BOX(NamespaceID.from("minecraft:brown_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:brown_shulker_box")),

    GREEN_SHULKER_BOX(NamespaceID.from("minecraft:green_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:green_shulker_box")),

    RED_SHULKER_BOX(NamespaceID.from("minecraft:red_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:red_shulker_box")),

    BLACK_SHULKER_BOX(NamespaceID.from("minecraft:black_shulker_box"), (byte) 1, () -> Registries.getBlock("minecraft:black_shulker_box")),

    WHITE_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:white_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:white_glazed_terracotta")),

    ORANGE_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:orange_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:orange_glazed_terracotta")),

    MAGENTA_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:magenta_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_glazed_terracotta")),

    LIGHT_BLUE_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:light_blue_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_glazed_terracotta")),

    YELLOW_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:yellow_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_glazed_terracotta")),

    LIME_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:lime_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:lime_glazed_terracotta")),

    PINK_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:pink_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:pink_glazed_terracotta")),

    GRAY_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:gray_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:gray_glazed_terracotta")),

    LIGHT_GRAY_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:light_gray_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_glazed_terracotta")),

    CYAN_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:cyan_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_glazed_terracotta")),

    PURPLE_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:purple_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:purple_glazed_terracotta")),

    BLUE_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:blue_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:blue_glazed_terracotta")),

    BROWN_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:brown_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:brown_glazed_terracotta")),

    GREEN_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:green_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:green_glazed_terracotta")),

    RED_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:red_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:red_glazed_terracotta")),

    BLACK_GLAZED_TERRACOTTA(NamespaceID.from("minecraft:black_glazed_terracotta"), (byte) 64, () -> Registries.getBlock("minecraft:black_glazed_terracotta")),

    WHITE_CONCRETE(NamespaceID.from("minecraft:white_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:white_concrete")),

    ORANGE_CONCRETE(NamespaceID.from("minecraft:orange_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:orange_concrete")),

    MAGENTA_CONCRETE(NamespaceID.from("minecraft:magenta_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_concrete")),

    LIGHT_BLUE_CONCRETE(NamespaceID.from("minecraft:light_blue_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_concrete")),

    YELLOW_CONCRETE(NamespaceID.from("minecraft:yellow_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_concrete")),

    LIME_CONCRETE(NamespaceID.from("minecraft:lime_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:lime_concrete")),

    PINK_CONCRETE(NamespaceID.from("minecraft:pink_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:pink_concrete")),

    GRAY_CONCRETE(NamespaceID.from("minecraft:gray_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:gray_concrete")),

    LIGHT_GRAY_CONCRETE(NamespaceID.from("minecraft:light_gray_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_concrete")),

    CYAN_CONCRETE(NamespaceID.from("minecraft:cyan_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_concrete")),

    PURPLE_CONCRETE(NamespaceID.from("minecraft:purple_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:purple_concrete")),

    BLUE_CONCRETE(NamespaceID.from("minecraft:blue_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:blue_concrete")),

    BROWN_CONCRETE(NamespaceID.from("minecraft:brown_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:brown_concrete")),

    GREEN_CONCRETE(NamespaceID.from("minecraft:green_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:green_concrete")),

    RED_CONCRETE(NamespaceID.from("minecraft:red_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:red_concrete")),

    BLACK_CONCRETE(NamespaceID.from("minecraft:black_concrete"), (byte) 64, () -> Registries.getBlock("minecraft:black_concrete")),

    WHITE_CONCRETE_POWDER(NamespaceID.from("minecraft:white_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:white_concrete_powder")),

    ORANGE_CONCRETE_POWDER(NamespaceID.from("minecraft:orange_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:orange_concrete_powder")),

    MAGENTA_CONCRETE_POWDER(NamespaceID.from("minecraft:magenta_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:magenta_concrete_powder")),

    LIGHT_BLUE_CONCRETE_POWDER(NamespaceID.from("minecraft:light_blue_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:light_blue_concrete_powder")),

    YELLOW_CONCRETE_POWDER(NamespaceID.from("minecraft:yellow_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:yellow_concrete_powder")),

    LIME_CONCRETE_POWDER(NamespaceID.from("minecraft:lime_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:lime_concrete_powder")),

    PINK_CONCRETE_POWDER(NamespaceID.from("minecraft:pink_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:pink_concrete_powder")),

    GRAY_CONCRETE_POWDER(NamespaceID.from("minecraft:gray_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:gray_concrete_powder")),

    LIGHT_GRAY_CONCRETE_POWDER(NamespaceID.from("minecraft:light_gray_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:light_gray_concrete_powder")),

    CYAN_CONCRETE_POWDER(NamespaceID.from("minecraft:cyan_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:cyan_concrete_powder")),

    PURPLE_CONCRETE_POWDER(NamespaceID.from("minecraft:purple_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:purple_concrete_powder")),

    BLUE_CONCRETE_POWDER(NamespaceID.from("minecraft:blue_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:blue_concrete_powder")),

    BROWN_CONCRETE_POWDER(NamespaceID.from("minecraft:brown_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:brown_concrete_powder")),

    GREEN_CONCRETE_POWDER(NamespaceID.from("minecraft:green_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:green_concrete_powder")),

    RED_CONCRETE_POWDER(NamespaceID.from("minecraft:red_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:red_concrete_powder")),

    BLACK_CONCRETE_POWDER(NamespaceID.from("minecraft:black_concrete_powder"), (byte) 64, () -> Registries.getBlock("minecraft:black_concrete_powder")),

    TURTLE_EGG(NamespaceID.from("minecraft:turtle_egg"), (byte) 64, () -> Registries.getBlock("minecraft:turtle_egg")),

    DEAD_TUBE_CORAL_BLOCK(NamespaceID.from("minecraft:dead_tube_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:dead_tube_coral_block")),

    DEAD_BRAIN_CORAL_BLOCK(NamespaceID.from("minecraft:dead_brain_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:dead_brain_coral_block")),

    DEAD_BUBBLE_CORAL_BLOCK(NamespaceID.from("minecraft:dead_bubble_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:dead_bubble_coral_block")),

    DEAD_FIRE_CORAL_BLOCK(NamespaceID.from("minecraft:dead_fire_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:dead_fire_coral_block")),

    DEAD_HORN_CORAL_BLOCK(NamespaceID.from("minecraft:dead_horn_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:dead_horn_coral_block")),

    TUBE_CORAL_BLOCK(NamespaceID.from("minecraft:tube_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:tube_coral_block")),

    BRAIN_CORAL_BLOCK(NamespaceID.from("minecraft:brain_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:brain_coral_block")),

    BUBBLE_CORAL_BLOCK(NamespaceID.from("minecraft:bubble_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:bubble_coral_block")),

    FIRE_CORAL_BLOCK(NamespaceID.from("minecraft:fire_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:fire_coral_block")),

    HORN_CORAL_BLOCK(NamespaceID.from("minecraft:horn_coral_block"), (byte) 64, () -> Registries.getBlock("minecraft:horn_coral_block")),

    TUBE_CORAL(NamespaceID.from("minecraft:tube_coral"), (byte) 64, () -> Registries.getBlock("minecraft:tube_coral")),

    BRAIN_CORAL(NamespaceID.from("minecraft:brain_coral"), (byte) 64, () -> Registries.getBlock("minecraft:brain_coral")),

    BUBBLE_CORAL(NamespaceID.from("minecraft:bubble_coral"), (byte) 64, () -> Registries.getBlock("minecraft:bubble_coral")),

    FIRE_CORAL(NamespaceID.from("minecraft:fire_coral"), (byte) 64, () -> Registries.getBlock("minecraft:fire_coral")),

    HORN_CORAL(NamespaceID.from("minecraft:horn_coral"), (byte) 64, () -> Registries.getBlock("minecraft:horn_coral")),

    DEAD_BRAIN_CORAL(NamespaceID.from("minecraft:dead_brain_coral"), (byte) 64, () -> Registries.getBlock("minecraft:dead_brain_coral")),

    DEAD_BUBBLE_CORAL(NamespaceID.from("minecraft:dead_bubble_coral"), (byte) 64, () -> Registries.getBlock("minecraft:dead_bubble_coral")),

    DEAD_FIRE_CORAL(NamespaceID.from("minecraft:dead_fire_coral"), (byte) 64, () -> Registries.getBlock("minecraft:dead_fire_coral")),

    DEAD_HORN_CORAL(NamespaceID.from("minecraft:dead_horn_coral"), (byte) 64, () -> Registries.getBlock("minecraft:dead_horn_coral")),

    DEAD_TUBE_CORAL(NamespaceID.from("minecraft:dead_tube_coral"), (byte) 64, () -> Registries.getBlock("minecraft:dead_tube_coral")),

    TUBE_CORAL_FAN(NamespaceID.from("minecraft:tube_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:tube_coral_fan")),

    BRAIN_CORAL_FAN(NamespaceID.from("minecraft:brain_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:brain_coral_fan")),

    BUBBLE_CORAL_FAN(NamespaceID.from("minecraft:bubble_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:bubble_coral_fan")),

    FIRE_CORAL_FAN(NamespaceID.from("minecraft:fire_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:fire_coral_fan")),

    HORN_CORAL_FAN(NamespaceID.from("minecraft:horn_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:horn_coral_fan")),

    DEAD_TUBE_CORAL_FAN(NamespaceID.from("minecraft:dead_tube_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:dead_tube_coral_fan")),

    DEAD_BRAIN_CORAL_FAN(NamespaceID.from("minecraft:dead_brain_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:dead_brain_coral_fan")),

    DEAD_BUBBLE_CORAL_FAN(NamespaceID.from("minecraft:dead_bubble_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:dead_bubble_coral_fan")),

    DEAD_FIRE_CORAL_FAN(NamespaceID.from("minecraft:dead_fire_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:dead_fire_coral_fan")),

    DEAD_HORN_CORAL_FAN(NamespaceID.from("minecraft:dead_horn_coral_fan"), (byte) 64, () -> Registries.getBlock("minecraft:dead_horn_coral_fan")),

    BLUE_ICE(NamespaceID.from("minecraft:blue_ice"), (byte) 64, () -> Registries.getBlock("minecraft:blue_ice")),

    CONDUIT(NamespaceID.from("minecraft:conduit"), (byte) 64, () -> Registries.getBlock("minecraft:conduit")),

    POLISHED_GRANITE_STAIRS(NamespaceID.from("minecraft:polished_granite_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:polished_granite_stairs")),

    SMOOTH_RED_SANDSTONE_STAIRS(NamespaceID.from("minecraft:smooth_red_sandstone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_red_sandstone_stairs")),

    MOSSY_STONE_BRICK_STAIRS(NamespaceID.from("minecraft:mossy_stone_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_stone_brick_stairs")),

    POLISHED_DIORITE_STAIRS(NamespaceID.from("minecraft:polished_diorite_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:polished_diorite_stairs")),

    MOSSY_COBBLESTONE_STAIRS(NamespaceID.from("minecraft:mossy_cobblestone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_cobblestone_stairs")),

    END_STONE_BRICK_STAIRS(NamespaceID.from("minecraft:end_stone_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:end_stone_brick_stairs")),

    STONE_STAIRS(NamespaceID.from("minecraft:stone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:stone_stairs")),

    SMOOTH_SANDSTONE_STAIRS(NamespaceID.from("minecraft:smooth_sandstone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_sandstone_stairs")),

    SMOOTH_QUARTZ_STAIRS(NamespaceID.from("minecraft:smooth_quartz_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_quartz_stairs")),

    GRANITE_STAIRS(NamespaceID.from("minecraft:granite_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:granite_stairs")),

    ANDESITE_STAIRS(NamespaceID.from("minecraft:andesite_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:andesite_stairs")),

    RED_NETHER_BRICK_STAIRS(NamespaceID.from("minecraft:red_nether_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:red_nether_brick_stairs")),

    POLISHED_ANDESITE_STAIRS(NamespaceID.from("minecraft:polished_andesite_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:polished_andesite_stairs")),

    DIORITE_STAIRS(NamespaceID.from("minecraft:diorite_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:diorite_stairs")),

    POLISHED_GRANITE_SLAB(NamespaceID.from("minecraft:polished_granite_slab"), (byte) 64, () -> Registries.getBlock("minecraft:polished_granite_slab")),

    SMOOTH_RED_SANDSTONE_SLAB(NamespaceID.from("minecraft:smooth_red_sandstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_red_sandstone_slab")),

    MOSSY_STONE_BRICK_SLAB(NamespaceID.from("minecraft:mossy_stone_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_stone_brick_slab")),

    POLISHED_DIORITE_SLAB(NamespaceID.from("minecraft:polished_diorite_slab"), (byte) 64, () -> Registries.getBlock("minecraft:polished_diorite_slab")),

    MOSSY_COBBLESTONE_SLAB(NamespaceID.from("minecraft:mossy_cobblestone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:mossy_cobblestone_slab")),

    END_STONE_BRICK_SLAB(NamespaceID.from("minecraft:end_stone_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:end_stone_brick_slab")),

    SMOOTH_SANDSTONE_SLAB(NamespaceID.from("minecraft:smooth_sandstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_sandstone_slab")),

    SMOOTH_QUARTZ_SLAB(NamespaceID.from("minecraft:smooth_quartz_slab"), (byte) 64, () -> Registries.getBlock("minecraft:smooth_quartz_slab")),

    GRANITE_SLAB(NamespaceID.from("minecraft:granite_slab"), (byte) 64, () -> Registries.getBlock("minecraft:granite_slab")),

    ANDESITE_SLAB(NamespaceID.from("minecraft:andesite_slab"), (byte) 64, () -> Registries.getBlock("minecraft:andesite_slab")),

    RED_NETHER_BRICK_SLAB(NamespaceID.from("minecraft:red_nether_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:red_nether_brick_slab")),

    POLISHED_ANDESITE_SLAB(NamespaceID.from("minecraft:polished_andesite_slab"), (byte) 64, () -> Registries.getBlock("minecraft:polished_andesite_slab")),

    DIORITE_SLAB(NamespaceID.from("minecraft:diorite_slab"), (byte) 64, () -> Registries.getBlock("minecraft:diorite_slab")),

    SCAFFOLDING(NamespaceID.from("minecraft:scaffolding"), (byte) 64, () -> Registries.getBlock("minecraft:scaffolding")),

    IRON_DOOR(NamespaceID.from("minecraft:iron_door"), (byte) 64, () -> Registries.getBlock("minecraft:iron_door")),

    OAK_DOOR(NamespaceID.from("minecraft:oak_door"), (byte) 64, () -> Registries.getBlock("minecraft:oak_door")),

    SPRUCE_DOOR(NamespaceID.from("minecraft:spruce_door"), (byte) 64, () -> Registries.getBlock("minecraft:spruce_door")),

    BIRCH_DOOR(NamespaceID.from("minecraft:birch_door"), (byte) 64, () -> Registries.getBlock("minecraft:birch_door")),

    JUNGLE_DOOR(NamespaceID.from("minecraft:jungle_door"), (byte) 64, () -> Registries.getBlock("minecraft:jungle_door")),

    ACACIA_DOOR(NamespaceID.from("minecraft:acacia_door"), (byte) 64, () -> Registries.getBlock("minecraft:acacia_door")),

    DARK_OAK_DOOR(NamespaceID.from("minecraft:dark_oak_door"), (byte) 64, () -> Registries.getBlock("minecraft:dark_oak_door")),

    CRIMSON_DOOR(NamespaceID.from("minecraft:crimson_door"), (byte) 64, () -> Registries.getBlock("minecraft:crimson_door")),

    WARPED_DOOR(NamespaceID.from("minecraft:warped_door"), (byte) 64, () -> Registries.getBlock("minecraft:warped_door")),

    REPEATER(NamespaceID.from("minecraft:repeater"), (byte) 64, () -> Registries.getBlock("minecraft:repeater")),

    COMPARATOR(NamespaceID.from("minecraft:comparator"), (byte) 64, () -> Registries.getBlock("minecraft:comparator")),

    STRUCTURE_BLOCK(NamespaceID.from("minecraft:structure_block"), (byte) 64, () -> Registries.getBlock("minecraft:structure_block")),

    JIGSAW(NamespaceID.from("minecraft:jigsaw"), (byte) 64, () -> Registries.getBlock("minecraft:jigsaw")),

    TURTLE_HELMET(NamespaceID.from("minecraft:turtle_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    SCUTE(NamespaceID.from("minecraft:scute"), (byte) 64, () -> null),

    FLINT_AND_STEEL(NamespaceID.from("minecraft:flint_and_steel"), (byte) 1, () -> null),

    APPLE(NamespaceID.from("minecraft:apple"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    BOW(NamespaceID.from("minecraft:bow"), (byte) 1, () -> null),

    ARROW(NamespaceID.from("minecraft:arrow"), (byte) 64, () -> null),

    COAL(NamespaceID.from("minecraft:coal"), (byte) 64, () -> null),

    CHARCOAL(NamespaceID.from("minecraft:charcoal"), (byte) 64, () -> null),

    DIAMOND(NamespaceID.from("minecraft:diamond"), (byte) 64, () -> null),

    IRON_INGOT(NamespaceID.from("minecraft:iron_ingot"), (byte) 64, () -> null),

    GOLD_INGOT(NamespaceID.from("minecraft:gold_ingot"), (byte) 64, () -> null),

    NETHERITE_INGOT(NamespaceID.from("minecraft:netherite_ingot"), (byte) 64, () -> null),

    NETHERITE_SCRAP(NamespaceID.from("minecraft:netherite_scrap"), (byte) 64, () -> null),

    WOODEN_SWORD(NamespaceID.from("minecraft:wooden_sword"), (byte) 1, () -> null),

    WOODEN_SHOVEL(NamespaceID.from("minecraft:wooden_shovel"), (byte) 1, () -> null),

    WOODEN_PICKAXE(NamespaceID.from("minecraft:wooden_pickaxe"), (byte) 1, () -> null),

    WOODEN_AXE(NamespaceID.from("minecraft:wooden_axe"), (byte) 1, () -> null),

    WOODEN_HOE(NamespaceID.from("minecraft:wooden_hoe"), (byte) 1, () -> null),

    STONE_SWORD(NamespaceID.from("minecraft:stone_sword"), (byte) 1, () -> null),

    STONE_SHOVEL(NamespaceID.from("minecraft:stone_shovel"), (byte) 1, () -> null),

    STONE_PICKAXE(NamespaceID.from("minecraft:stone_pickaxe"), (byte) 1, () -> null),

    STONE_AXE(NamespaceID.from("minecraft:stone_axe"), (byte) 1, () -> null),

    STONE_HOE(NamespaceID.from("minecraft:stone_hoe"), (byte) 1, () -> null),

    GOLDEN_SWORD(NamespaceID.from("minecraft:golden_sword"), (byte) 1, () -> null),

    GOLDEN_SHOVEL(NamespaceID.from("minecraft:golden_shovel"), (byte) 1, () -> null),

    GOLDEN_PICKAXE(NamespaceID.from("minecraft:golden_pickaxe"), (byte) 1, () -> null),

    GOLDEN_AXE(NamespaceID.from("minecraft:golden_axe"), (byte) 1, () -> null),

    GOLDEN_HOE(NamespaceID.from("minecraft:golden_hoe"), (byte) 1, () -> null),

    IRON_SWORD(NamespaceID.from("minecraft:iron_sword"), (byte) 1, () -> null),

    IRON_SHOVEL(NamespaceID.from("minecraft:iron_shovel"), (byte) 1, () -> null),

    IRON_PICKAXE(NamespaceID.from("minecraft:iron_pickaxe"), (byte) 1, () -> null),

    IRON_AXE(NamespaceID.from("minecraft:iron_axe"), (byte) 1, () -> null),

    IRON_HOE(NamespaceID.from("minecraft:iron_hoe"), (byte) 1, () -> null),

    DIAMOND_SWORD(NamespaceID.from("minecraft:diamond_sword"), (byte) 1, () -> null),

    DIAMOND_SHOVEL(NamespaceID.from("minecraft:diamond_shovel"), (byte) 1, () -> null),

    DIAMOND_PICKAXE(NamespaceID.from("minecraft:diamond_pickaxe"), (byte) 1, () -> null),

    DIAMOND_AXE(NamespaceID.from("minecraft:diamond_axe"), (byte) 1, () -> null),

    DIAMOND_HOE(NamespaceID.from("minecraft:diamond_hoe"), (byte) 1, () -> null),

    NETHERITE_SWORD(NamespaceID.from("minecraft:netherite_sword"), (byte) 1, () -> null),

    NETHERITE_SHOVEL(NamespaceID.from("minecraft:netherite_shovel"), (byte) 1, () -> null),

    NETHERITE_PICKAXE(NamespaceID.from("minecraft:netherite_pickaxe"), (byte) 1, () -> null),

    NETHERITE_AXE(NamespaceID.from("minecraft:netherite_axe"), (byte) 1, () -> null),

    NETHERITE_HOE(NamespaceID.from("minecraft:netherite_hoe"), (byte) 1, () -> null),

    STICK(NamespaceID.from("minecraft:stick"), (byte) 64, () -> null),

    BOWL(NamespaceID.from("minecraft:bowl"), (byte) 64, () -> null),

    MUSHROOM_STEW(NamespaceID.from("minecraft:mushroom_stew"), (byte) 1, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    STRING(NamespaceID.from("minecraft:string"), (byte) 64, () -> Registries.getBlock("minecraft:tripwire")),

    FEATHER(NamespaceID.from("minecraft:feather"), (byte) 64, () -> null),

    GUNPOWDER(NamespaceID.from("minecraft:gunpowder"), (byte) 64, () -> null),

    WHEAT_SEEDS(NamespaceID.from("minecraft:wheat_seeds"), (byte) 64, () -> Registries.getBlock("minecraft:wheat")),

    WHEAT(NamespaceID.from("minecraft:wheat"), (byte) 64, () -> null),

    BREAD(NamespaceID.from("minecraft:bread"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    LEATHER_HELMET(NamespaceID.from("minecraft:leather_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    LEATHER_CHESTPLATE(NamespaceID.from("minecraft:leather_chestplate"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isChestplate() {
            return true;
        }
    },

    LEATHER_LEGGINGS(NamespaceID.from("minecraft:leather_leggings"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isLeggings() {
            return true;
        }
    },

    LEATHER_BOOTS(NamespaceID.from("minecraft:leather_boots"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isBoots() {
            return true;
        }
    },

    CHAINMAIL_HELMET(NamespaceID.from("minecraft:chainmail_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    CHAINMAIL_CHESTPLATE(NamespaceID.from("minecraft:chainmail_chestplate"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isChestplate() {
            return true;
        }
    },

    CHAINMAIL_LEGGINGS(NamespaceID.from("minecraft:chainmail_leggings"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isLeggings() {
            return true;
        }
    },

    CHAINMAIL_BOOTS(NamespaceID.from("minecraft:chainmail_boots"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isBoots() {
            return true;
        }
    },

    IRON_HELMET(NamespaceID.from("minecraft:iron_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    IRON_CHESTPLATE(NamespaceID.from("minecraft:iron_chestplate"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isChestplate() {
            return true;
        }
    },

    IRON_LEGGINGS(NamespaceID.from("minecraft:iron_leggings"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isLeggings() {
            return true;
        }
    },

    IRON_BOOTS(NamespaceID.from("minecraft:iron_boots"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isBoots() {
            return true;
        }
    },

    DIAMOND_HELMET(NamespaceID.from("minecraft:diamond_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    DIAMOND_CHESTPLATE(NamespaceID.from("minecraft:diamond_chestplate"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isChestplate() {
            return true;
        }
    },

    DIAMOND_LEGGINGS(NamespaceID.from("minecraft:diamond_leggings"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isLeggings() {
            return true;
        }
    },

    DIAMOND_BOOTS(NamespaceID.from("minecraft:diamond_boots"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isBoots() {
            return true;
        }
    },

    GOLDEN_HELMET(NamespaceID.from("minecraft:golden_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    GOLDEN_CHESTPLATE(NamespaceID.from("minecraft:golden_chestplate"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isChestplate() {
            return true;
        }
    },

    GOLDEN_LEGGINGS(NamespaceID.from("minecraft:golden_leggings"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isLeggings() {
            return true;
        }
    },

    GOLDEN_BOOTS(NamespaceID.from("minecraft:golden_boots"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isBoots() {
            return true;
        }
    },

    NETHERITE_HELMET(NamespaceID.from("minecraft:netherite_helmet"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isHelmet() {
            return true;
        }
    },

    NETHERITE_CHESTPLATE(NamespaceID.from("minecraft:netherite_chestplate"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isChestplate() {
            return true;
        }
    },

    NETHERITE_LEGGINGS(NamespaceID.from("minecraft:netherite_leggings"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isLeggings() {
            return true;
        }
    },

    NETHERITE_BOOTS(NamespaceID.from("minecraft:netherite_boots"), (byte) 1, () -> null) {
        @Override
        public boolean isArmor() {
            return true;
        }

        @Override
        public boolean isBoots() {
            return true;
        }
    },

    FLINT(NamespaceID.from("minecraft:flint"), (byte) 64, () -> null),

    PORKCHOP(NamespaceID.from("minecraft:porkchop"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_PORKCHOP(NamespaceID.from("minecraft:cooked_porkchop"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    PAINTING(NamespaceID.from("minecraft:painting"), (byte) 64, () -> null),

    GOLDEN_APPLE(NamespaceID.from("minecraft:golden_apple"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    ENCHANTED_GOLDEN_APPLE(NamespaceID.from("minecraft:enchanted_golden_apple"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    OAK_SIGN(NamespaceID.from("minecraft:oak_sign"), (byte) 16, () -> Registries.getBlock("minecraft:oak_sign")),

    SPRUCE_SIGN(NamespaceID.from("minecraft:spruce_sign"), (byte) 16, () -> Registries.getBlock("minecraft:spruce_sign")),

    BIRCH_SIGN(NamespaceID.from("minecraft:birch_sign"), (byte) 16, () -> Registries.getBlock("minecraft:birch_sign")),

    JUNGLE_SIGN(NamespaceID.from("minecraft:jungle_sign"), (byte) 16, () -> Registries.getBlock("minecraft:jungle_sign")),

    ACACIA_SIGN(NamespaceID.from("minecraft:acacia_sign"), (byte) 16, () -> Registries.getBlock("minecraft:acacia_sign")),

    DARK_OAK_SIGN(NamespaceID.from("minecraft:dark_oak_sign"), (byte) 16, () -> Registries.getBlock("minecraft:dark_oak_sign")),

    CRIMSON_SIGN(NamespaceID.from("minecraft:crimson_sign"), (byte) 16, () -> Registries.getBlock("minecraft:crimson_sign")),

    WARPED_SIGN(NamespaceID.from("minecraft:warped_sign"), (byte) 16, () -> Registries.getBlock("minecraft:warped_sign")),

    BUCKET(NamespaceID.from("minecraft:bucket"), (byte) 16, () -> null),

    WATER_BUCKET(NamespaceID.from("minecraft:water_bucket"), (byte) 1, () -> null),

    LAVA_BUCKET(NamespaceID.from("minecraft:lava_bucket"), (byte) 1, () -> null),

    MINECART(NamespaceID.from("minecraft:minecart"), (byte) 1, () -> null),

    SADDLE(NamespaceID.from("minecraft:saddle"), (byte) 1, () -> null),

    REDSTONE(NamespaceID.from("minecraft:redstone"), (byte) 64, () -> Registries.getBlock("minecraft:redstone_wire")),

    SNOWBALL(NamespaceID.from("minecraft:snowball"), (byte) 16, () -> null),

    OAK_BOAT(NamespaceID.from("minecraft:oak_boat"), (byte) 1, () -> null),

    LEATHER(NamespaceID.from("minecraft:leather"), (byte) 64, () -> null),

    MILK_BUCKET(NamespaceID.from("minecraft:milk_bucket"), (byte) 1, () -> null),

    PUFFERFISH_BUCKET(NamespaceID.from("minecraft:pufferfish_bucket"), (byte) 1, () -> null),

    SALMON_BUCKET(NamespaceID.from("minecraft:salmon_bucket"), (byte) 1, () -> null),

    COD_BUCKET(NamespaceID.from("minecraft:cod_bucket"), (byte) 1, () -> null),

    TROPICAL_FISH_BUCKET(NamespaceID.from("minecraft:tropical_fish_bucket"), (byte) 1, () -> null),

    BRICK(NamespaceID.from("minecraft:brick"), (byte) 64, () -> null),

    CLAY_BALL(NamespaceID.from("minecraft:clay_ball"), (byte) 64, () -> null),

    DRIED_KELP_BLOCK(NamespaceID.from("minecraft:dried_kelp_block"), (byte) 64, () -> Registries.getBlock("minecraft:dried_kelp_block")),

    PAPER(NamespaceID.from("minecraft:paper"), (byte) 64, () -> null),

    BOOK(NamespaceID.from("minecraft:book"), (byte) 64, () -> null),

    SLIME_BALL(NamespaceID.from("minecraft:slime_ball"), (byte) 64, () -> null),

    CHEST_MINECART(NamespaceID.from("minecraft:chest_minecart"), (byte) 1, () -> null),

    FURNACE_MINECART(NamespaceID.from("minecraft:furnace_minecart"), (byte) 1, () -> null),

    EGG(NamespaceID.from("minecraft:egg"), (byte) 16, () -> null),

    COMPASS(NamespaceID.from("minecraft:compass"), (byte) 64, () -> null),

    FISHING_ROD(NamespaceID.from("minecraft:fishing_rod"), (byte) 1, () -> null),

    CLOCK(NamespaceID.from("minecraft:clock"), (byte) 64, () -> null),

    GLOWSTONE_DUST(NamespaceID.from("minecraft:glowstone_dust"), (byte) 64, () -> null),

    COD(NamespaceID.from("minecraft:cod"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    SALMON(NamespaceID.from("minecraft:salmon"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    TROPICAL_FISH(NamespaceID.from("minecraft:tropical_fish"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    PUFFERFISH(NamespaceID.from("minecraft:pufferfish"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_COD(NamespaceID.from("minecraft:cooked_cod"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_SALMON(NamespaceID.from("minecraft:cooked_salmon"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    INK_SAC(NamespaceID.from("minecraft:ink_sac"), (byte) 64, () -> null),

    COCOA_BEANS(NamespaceID.from("minecraft:cocoa_beans"), (byte) 64, () -> Registries.getBlock("minecraft:cocoa")),

    LAPIS_LAZULI(NamespaceID.from("minecraft:lapis_lazuli"), (byte) 64, () -> null),

    WHITE_DYE(NamespaceID.from("minecraft:white_dye"), (byte) 64, () -> null),

    ORANGE_DYE(NamespaceID.from("minecraft:orange_dye"), (byte) 64, () -> null),

    MAGENTA_DYE(NamespaceID.from("minecraft:magenta_dye"), (byte) 64, () -> null),

    LIGHT_BLUE_DYE(NamespaceID.from("minecraft:light_blue_dye"), (byte) 64, () -> null),

    YELLOW_DYE(NamespaceID.from("minecraft:yellow_dye"), (byte) 64, () -> null),

    LIME_DYE(NamespaceID.from("minecraft:lime_dye"), (byte) 64, () -> null),

    PINK_DYE(NamespaceID.from("minecraft:pink_dye"), (byte) 64, () -> null),

    GRAY_DYE(NamespaceID.from("minecraft:gray_dye"), (byte) 64, () -> null),

    LIGHT_GRAY_DYE(NamespaceID.from("minecraft:light_gray_dye"), (byte) 64, () -> null),

    CYAN_DYE(NamespaceID.from("minecraft:cyan_dye"), (byte) 64, () -> null),

    PURPLE_DYE(NamespaceID.from("minecraft:purple_dye"), (byte) 64, () -> null),

    BLUE_DYE(NamespaceID.from("minecraft:blue_dye"), (byte) 64, () -> null),

    BROWN_DYE(NamespaceID.from("minecraft:brown_dye"), (byte) 64, () -> null),

    GREEN_DYE(NamespaceID.from("minecraft:green_dye"), (byte) 64, () -> null),

    RED_DYE(NamespaceID.from("minecraft:red_dye"), (byte) 64, () -> null),

    BLACK_DYE(NamespaceID.from("minecraft:black_dye"), (byte) 64, () -> null),

    BONE_MEAL(NamespaceID.from("minecraft:bone_meal"), (byte) 64, () -> null),

    BONE(NamespaceID.from("minecraft:bone"), (byte) 64, () -> null),

    SUGAR(NamespaceID.from("minecraft:sugar"), (byte) 64, () -> null),

    CAKE(NamespaceID.from("minecraft:cake"), (byte) 1, () -> Registries.getBlock("minecraft:cake")),

    WHITE_BED(NamespaceID.from("minecraft:white_bed"), (byte) 1, () -> Registries.getBlock("minecraft:white_bed")),

    ORANGE_BED(NamespaceID.from("minecraft:orange_bed"), (byte) 1, () -> Registries.getBlock("minecraft:orange_bed")),

    MAGENTA_BED(NamespaceID.from("minecraft:magenta_bed"), (byte) 1, () -> Registries.getBlock("minecraft:magenta_bed")),

    LIGHT_BLUE_BED(NamespaceID.from("minecraft:light_blue_bed"), (byte) 1, () -> Registries.getBlock("minecraft:light_blue_bed")),

    YELLOW_BED(NamespaceID.from("minecraft:yellow_bed"), (byte) 1, () -> Registries.getBlock("minecraft:yellow_bed")),

    LIME_BED(NamespaceID.from("minecraft:lime_bed"), (byte) 1, () -> Registries.getBlock("minecraft:lime_bed")),

    PINK_BED(NamespaceID.from("minecraft:pink_bed"), (byte) 1, () -> Registries.getBlock("minecraft:pink_bed")),

    GRAY_BED(NamespaceID.from("minecraft:gray_bed"), (byte) 1, () -> Registries.getBlock("minecraft:gray_bed")),

    LIGHT_GRAY_BED(NamespaceID.from("minecraft:light_gray_bed"), (byte) 1, () -> Registries.getBlock("minecraft:light_gray_bed")),

    CYAN_BED(NamespaceID.from("minecraft:cyan_bed"), (byte) 1, () -> Registries.getBlock("minecraft:cyan_bed")),

    PURPLE_BED(NamespaceID.from("minecraft:purple_bed"), (byte) 1, () -> Registries.getBlock("minecraft:purple_bed")),

    BLUE_BED(NamespaceID.from("minecraft:blue_bed"), (byte) 1, () -> Registries.getBlock("minecraft:blue_bed")),

    BROWN_BED(NamespaceID.from("minecraft:brown_bed"), (byte) 1, () -> Registries.getBlock("minecraft:brown_bed")),

    GREEN_BED(NamespaceID.from("minecraft:green_bed"), (byte) 1, () -> Registries.getBlock("minecraft:green_bed")),

    RED_BED(NamespaceID.from("minecraft:red_bed"), (byte) 1, () -> Registries.getBlock("minecraft:red_bed")),

    BLACK_BED(NamespaceID.from("minecraft:black_bed"), (byte) 1, () -> Registries.getBlock("minecraft:black_bed")),

    COOKIE(NamespaceID.from("minecraft:cookie"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    FILLED_MAP(NamespaceID.from("minecraft:filled_map"), (byte) 64, () -> null),

    SHEARS(NamespaceID.from("minecraft:shears"), (byte) 1, () -> null),

    MELON_SLICE(NamespaceID.from("minecraft:melon_slice"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    DRIED_KELP(NamespaceID.from("minecraft:dried_kelp"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    PUMPKIN_SEEDS(NamespaceID.from("minecraft:pumpkin_seeds"), (byte) 64, () -> Registries.getBlock("minecraft:pumpkin_stem")),

    MELON_SEEDS(NamespaceID.from("minecraft:melon_seeds"), (byte) 64, () -> Registries.getBlock("minecraft:melon_stem")),

    BEEF(NamespaceID.from("minecraft:beef"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_BEEF(NamespaceID.from("minecraft:cooked_beef"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    CHICKEN(NamespaceID.from("minecraft:chicken"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_CHICKEN(NamespaceID.from("minecraft:cooked_chicken"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    ROTTEN_FLESH(NamespaceID.from("minecraft:rotten_flesh"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    ENDER_PEARL(NamespaceID.from("minecraft:ender_pearl"), (byte) 16, () -> null),

    BLAZE_ROD(NamespaceID.from("minecraft:blaze_rod"), (byte) 64, () -> null),

    GHAST_TEAR(NamespaceID.from("minecraft:ghast_tear"), (byte) 64, () -> null),

    GOLD_NUGGET(NamespaceID.from("minecraft:gold_nugget"), (byte) 64, () -> null),

    NETHER_WART(NamespaceID.from("minecraft:nether_wart"), (byte) 64, () -> Registries.getBlock("minecraft:nether_wart")),

    POTION(NamespaceID.from("minecraft:potion"), (byte) 1, () -> null),

    GLASS_BOTTLE(NamespaceID.from("minecraft:glass_bottle"), (byte) 64, () -> null),

    SPIDER_EYE(NamespaceID.from("minecraft:spider_eye"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    FERMENTED_SPIDER_EYE(NamespaceID.from("minecraft:fermented_spider_eye"), (byte) 64, () -> null),

    BLAZE_POWDER(NamespaceID.from("minecraft:blaze_powder"), (byte) 64, () -> null),

    MAGMA_CREAM(NamespaceID.from("minecraft:magma_cream"), (byte) 64, () -> null),

    BREWING_STAND(NamespaceID.from("minecraft:brewing_stand"), (byte) 64, () -> Registries.getBlock("minecraft:brewing_stand")),

    CAULDRON(NamespaceID.from("minecraft:cauldron"), (byte) 64, () -> Registries.getBlock("minecraft:cauldron")),

    ENDER_EYE(NamespaceID.from("minecraft:ender_eye"), (byte) 64, () -> null),

    GLISTERING_MELON_SLICE(NamespaceID.from("minecraft:glistering_melon_slice"), (byte) 64, () -> null),

    BAT_SPAWN_EGG(NamespaceID.from("minecraft:bat_spawn_egg"), (byte) 64, () -> null),

    BEE_SPAWN_EGG(NamespaceID.from("minecraft:bee_spawn_egg"), (byte) 64, () -> null),

    BLAZE_SPAWN_EGG(NamespaceID.from("minecraft:blaze_spawn_egg"), (byte) 64, () -> null),

    CAT_SPAWN_EGG(NamespaceID.from("minecraft:cat_spawn_egg"), (byte) 64, () -> null),

    CAVE_SPIDER_SPAWN_EGG(NamespaceID.from("minecraft:cave_spider_spawn_egg"), (byte) 64, () -> null),

    CHICKEN_SPAWN_EGG(NamespaceID.from("minecraft:chicken_spawn_egg"), (byte) 64, () -> null),

    COD_SPAWN_EGG(NamespaceID.from("minecraft:cod_spawn_egg"), (byte) 64, () -> null),

    COW_SPAWN_EGG(NamespaceID.from("minecraft:cow_spawn_egg"), (byte) 64, () -> null),

    CREEPER_SPAWN_EGG(NamespaceID.from("minecraft:creeper_spawn_egg"), (byte) 64, () -> null),

    DOLPHIN_SPAWN_EGG(NamespaceID.from("minecraft:dolphin_spawn_egg"), (byte) 64, () -> null),

    DONKEY_SPAWN_EGG(NamespaceID.from("minecraft:donkey_spawn_egg"), (byte) 64, () -> null),

    DROWNED_SPAWN_EGG(NamespaceID.from("minecraft:drowned_spawn_egg"), (byte) 64, () -> null),

    ELDER_GUARDIAN_SPAWN_EGG(NamespaceID.from("minecraft:elder_guardian_spawn_egg"), (byte) 64, () -> null),

    ENDERMAN_SPAWN_EGG(NamespaceID.from("minecraft:enderman_spawn_egg"), (byte) 64, () -> null),

    ENDERMITE_SPAWN_EGG(NamespaceID.from("minecraft:endermite_spawn_egg"), (byte) 64, () -> null),

    EVOKER_SPAWN_EGG(NamespaceID.from("minecraft:evoker_spawn_egg"), (byte) 64, () -> null),

    FOX_SPAWN_EGG(NamespaceID.from("minecraft:fox_spawn_egg"), (byte) 64, () -> null),

    GHAST_SPAWN_EGG(NamespaceID.from("minecraft:ghast_spawn_egg"), (byte) 64, () -> null),

    GUARDIAN_SPAWN_EGG(NamespaceID.from("minecraft:guardian_spawn_egg"), (byte) 64, () -> null),

    HOGLIN_SPAWN_EGG(NamespaceID.from("minecraft:hoglin_spawn_egg"), (byte) 64, () -> null),

    HORSE_SPAWN_EGG(NamespaceID.from("minecraft:horse_spawn_egg"), (byte) 64, () -> null),

    HUSK_SPAWN_EGG(NamespaceID.from("minecraft:husk_spawn_egg"), (byte) 64, () -> null),

    LLAMA_SPAWN_EGG(NamespaceID.from("minecraft:llama_spawn_egg"), (byte) 64, () -> null),

    MAGMA_CUBE_SPAWN_EGG(NamespaceID.from("minecraft:magma_cube_spawn_egg"), (byte) 64, () -> null),

    MOOSHROOM_SPAWN_EGG(NamespaceID.from("minecraft:mooshroom_spawn_egg"), (byte) 64, () -> null),

    MULE_SPAWN_EGG(NamespaceID.from("minecraft:mule_spawn_egg"), (byte) 64, () -> null),

    OCELOT_SPAWN_EGG(NamespaceID.from("minecraft:ocelot_spawn_egg"), (byte) 64, () -> null),

    PANDA_SPAWN_EGG(NamespaceID.from("minecraft:panda_spawn_egg"), (byte) 64, () -> null),

    PARROT_SPAWN_EGG(NamespaceID.from("minecraft:parrot_spawn_egg"), (byte) 64, () -> null),

    PHANTOM_SPAWN_EGG(NamespaceID.from("minecraft:phantom_spawn_egg"), (byte) 64, () -> null),

    PIG_SPAWN_EGG(NamespaceID.from("minecraft:pig_spawn_egg"), (byte) 64, () -> null),

    PIGLIN_SPAWN_EGG(NamespaceID.from("minecraft:piglin_spawn_egg"), (byte) 64, () -> null),

    PIGLIN_BRUTE_SPAWN_EGG(NamespaceID.from("minecraft:piglin_brute_spawn_egg"), (byte) 64, () -> null),

    PILLAGER_SPAWN_EGG(NamespaceID.from("minecraft:pillager_spawn_egg"), (byte) 64, () -> null),

    POLAR_BEAR_SPAWN_EGG(NamespaceID.from("minecraft:polar_bear_spawn_egg"), (byte) 64, () -> null),

    PUFFERFISH_SPAWN_EGG(NamespaceID.from("minecraft:pufferfish_spawn_egg"), (byte) 64, () -> null),

    RABBIT_SPAWN_EGG(NamespaceID.from("minecraft:rabbit_spawn_egg"), (byte) 64, () -> null),

    RAVAGER_SPAWN_EGG(NamespaceID.from("minecraft:ravager_spawn_egg"), (byte) 64, () -> null),

    SALMON_SPAWN_EGG(NamespaceID.from("minecraft:salmon_spawn_egg"), (byte) 64, () -> null),

    SHEEP_SPAWN_EGG(NamespaceID.from("minecraft:sheep_spawn_egg"), (byte) 64, () -> null),

    SHULKER_SPAWN_EGG(NamespaceID.from("minecraft:shulker_spawn_egg"), (byte) 64, () -> null),

    SILVERFISH_SPAWN_EGG(NamespaceID.from("minecraft:silverfish_spawn_egg"), (byte) 64, () -> null),

    SKELETON_SPAWN_EGG(NamespaceID.from("minecraft:skeleton_spawn_egg"), (byte) 64, () -> null),

    SKELETON_HORSE_SPAWN_EGG(NamespaceID.from("minecraft:skeleton_horse_spawn_egg"), (byte) 64, () -> null),

    SLIME_SPAWN_EGG(NamespaceID.from("minecraft:slime_spawn_egg"), (byte) 64, () -> null),

    SPIDER_SPAWN_EGG(NamespaceID.from("minecraft:spider_spawn_egg"), (byte) 64, () -> null),

    SQUID_SPAWN_EGG(NamespaceID.from("minecraft:squid_spawn_egg"), (byte) 64, () -> null),

    STRAY_SPAWN_EGG(NamespaceID.from("minecraft:stray_spawn_egg"), (byte) 64, () -> null),

    STRIDER_SPAWN_EGG(NamespaceID.from("minecraft:strider_spawn_egg"), (byte) 64, () -> null),

    TRADER_LLAMA_SPAWN_EGG(NamespaceID.from("minecraft:trader_llama_spawn_egg"), (byte) 64, () -> null),

    TROPICAL_FISH_SPAWN_EGG(NamespaceID.from("minecraft:tropical_fish_spawn_egg"), (byte) 64, () -> null),

    TURTLE_SPAWN_EGG(NamespaceID.from("minecraft:turtle_spawn_egg"), (byte) 64, () -> null),

    VEX_SPAWN_EGG(NamespaceID.from("minecraft:vex_spawn_egg"), (byte) 64, () -> null),

    VILLAGER_SPAWN_EGG(NamespaceID.from("minecraft:villager_spawn_egg"), (byte) 64, () -> null),

    VINDICATOR_SPAWN_EGG(NamespaceID.from("minecraft:vindicator_spawn_egg"), (byte) 64, () -> null),

    WANDERING_TRADER_SPAWN_EGG(NamespaceID.from("minecraft:wandering_trader_spawn_egg"), (byte) 64, () -> null),

    WITCH_SPAWN_EGG(NamespaceID.from("minecraft:witch_spawn_egg"), (byte) 64, () -> null),

    WITHER_SKELETON_SPAWN_EGG(NamespaceID.from("minecraft:wither_skeleton_spawn_egg"), (byte) 64, () -> null),

    WOLF_SPAWN_EGG(NamespaceID.from("minecraft:wolf_spawn_egg"), (byte) 64, () -> null),

    ZOGLIN_SPAWN_EGG(NamespaceID.from("minecraft:zoglin_spawn_egg"), (byte) 64, () -> null),

    ZOMBIE_SPAWN_EGG(NamespaceID.from("minecraft:zombie_spawn_egg"), (byte) 64, () -> null),

    ZOMBIE_HORSE_SPAWN_EGG(NamespaceID.from("minecraft:zombie_horse_spawn_egg"), (byte) 64, () -> null),

    ZOMBIE_VILLAGER_SPAWN_EGG(NamespaceID.from("minecraft:zombie_villager_spawn_egg"), (byte) 64, () -> null),

    ZOMBIFIED_PIGLIN_SPAWN_EGG(NamespaceID.from("minecraft:zombified_piglin_spawn_egg"), (byte) 64, () -> null),

    EXPERIENCE_BOTTLE(NamespaceID.from("minecraft:experience_bottle"), (byte) 64, () -> null),

    FIRE_CHARGE(NamespaceID.from("minecraft:fire_charge"), (byte) 64, () -> null),

    WRITABLE_BOOK(NamespaceID.from("minecraft:writable_book"), (byte) 1, () -> null),

    WRITTEN_BOOK(NamespaceID.from("minecraft:written_book"), (byte) 16, () -> null),

    EMERALD(NamespaceID.from("minecraft:emerald"), (byte) 64, () -> null),

    ITEM_FRAME(NamespaceID.from("minecraft:item_frame"), (byte) 64, () -> null),

    FLOWER_POT(NamespaceID.from("minecraft:flower_pot"), (byte) 64, () -> Registries.getBlock("minecraft:flower_pot")),

    CARROT(NamespaceID.from("minecraft:carrot"), (byte) 64, () -> Registries.getBlock("minecraft:carrots")) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    POTATO(NamespaceID.from("minecraft:potato"), (byte) 64, () -> Registries.getBlock("minecraft:potatoes")) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    BAKED_POTATO(NamespaceID.from("minecraft:baked_potato"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    POISONOUS_POTATO(NamespaceID.from("minecraft:poisonous_potato"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    MAP(NamespaceID.from("minecraft:map"), (byte) 64, () -> null),

    GOLDEN_CARROT(NamespaceID.from("minecraft:golden_carrot"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    SKELETON_SKULL(NamespaceID.from("minecraft:skeleton_skull"), (byte) 64, () -> Registries.getBlock("minecraft:skeleton_skull")),

    WITHER_SKELETON_SKULL(NamespaceID.from("minecraft:wither_skeleton_skull"), (byte) 64, () -> Registries.getBlock("minecraft:wither_skeleton_skull")),

    PLAYER_HEAD(NamespaceID.from("minecraft:player_head"), (byte) 64, () -> Registries.getBlock("minecraft:player_head")),

    ZOMBIE_HEAD(NamespaceID.from("minecraft:zombie_head"), (byte) 64, () -> Registries.getBlock("minecraft:zombie_head")),

    CREEPER_HEAD(NamespaceID.from("minecraft:creeper_head"), (byte) 64, () -> Registries.getBlock("minecraft:creeper_head")),

    DRAGON_HEAD(NamespaceID.from("minecraft:dragon_head"), (byte) 64, () -> Registries.getBlock("minecraft:dragon_head")),

    CARROT_ON_A_STICK(NamespaceID.from("minecraft:carrot_on_a_stick"), (byte) 1, () -> null),

    WARPED_FUNGUS_ON_A_STICK(NamespaceID.from("minecraft:warped_fungus_on_a_stick"), (byte) 1, () -> null),

    NETHER_STAR(NamespaceID.from("minecraft:nether_star"), (byte) 64, () -> null),

    PUMPKIN_PIE(NamespaceID.from("minecraft:pumpkin_pie"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    FIREWORK_ROCKET(NamespaceID.from("minecraft:firework_rocket"), (byte) 64, () -> null),

    FIREWORK_STAR(NamespaceID.from("minecraft:firework_star"), (byte) 64, () -> null),

    ENCHANTED_BOOK(NamespaceID.from("minecraft:enchanted_book"), (byte) 1, () -> null),

    NETHER_BRICK(NamespaceID.from("minecraft:nether_brick"), (byte) 64, () -> null),

    QUARTZ(NamespaceID.from("minecraft:quartz"), (byte) 64, () -> null),

    TNT_MINECART(NamespaceID.from("minecraft:tnt_minecart"), (byte) 1, () -> null),

    HOPPER_MINECART(NamespaceID.from("minecraft:hopper_minecart"), (byte) 1, () -> null),

    PRISMARINE_SHARD(NamespaceID.from("minecraft:prismarine_shard"), (byte) 64, () -> null),

    PRISMARINE_CRYSTALS(NamespaceID.from("minecraft:prismarine_crystals"), (byte) 64, () -> null),

    RABBIT(NamespaceID.from("minecraft:rabbit"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_RABBIT(NamespaceID.from("minecraft:cooked_rabbit"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    RABBIT_STEW(NamespaceID.from("minecraft:rabbit_stew"), (byte) 1, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    RABBIT_FOOT(NamespaceID.from("minecraft:rabbit_foot"), (byte) 64, () -> null),

    RABBIT_HIDE(NamespaceID.from("minecraft:rabbit_hide"), (byte) 64, () -> null),

    ARMOR_STAND(NamespaceID.from("minecraft:armor_stand"), (byte) 16, () -> null),

    IRON_HORSE_ARMOR(NamespaceID.from("minecraft:iron_horse_armor"), (byte) 1, () -> null),

    GOLDEN_HORSE_ARMOR(NamespaceID.from("minecraft:golden_horse_armor"), (byte) 1, () -> null),

    DIAMOND_HORSE_ARMOR(NamespaceID.from("minecraft:diamond_horse_armor"), (byte) 1, () -> null),

    LEATHER_HORSE_ARMOR(NamespaceID.from("minecraft:leather_horse_armor"), (byte) 1, () -> null),

    LEAD(NamespaceID.from("minecraft:lead"), (byte) 64, () -> null),

    NAME_TAG(NamespaceID.from("minecraft:name_tag"), (byte) 64, () -> null),

    COMMAND_BLOCK_MINECART(NamespaceID.from("minecraft:command_block_minecart"), (byte) 1, () -> null),

    MUTTON(NamespaceID.from("minecraft:mutton"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    COOKED_MUTTON(NamespaceID.from("minecraft:cooked_mutton"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    WHITE_BANNER(NamespaceID.from("minecraft:white_banner"), (byte) 16, () -> Registries.getBlock("minecraft:white_banner")),

    ORANGE_BANNER(NamespaceID.from("minecraft:orange_banner"), (byte) 16, () -> Registries.getBlock("minecraft:orange_banner")),

    MAGENTA_BANNER(NamespaceID.from("minecraft:magenta_banner"), (byte) 16, () -> Registries.getBlock("minecraft:magenta_banner")),

    LIGHT_BLUE_BANNER(NamespaceID.from("minecraft:light_blue_banner"), (byte) 16, () -> Registries.getBlock("minecraft:light_blue_banner")),

    YELLOW_BANNER(NamespaceID.from("minecraft:yellow_banner"), (byte) 16, () -> Registries.getBlock("minecraft:yellow_banner")),

    LIME_BANNER(NamespaceID.from("minecraft:lime_banner"), (byte) 16, () -> Registries.getBlock("minecraft:lime_banner")),

    PINK_BANNER(NamespaceID.from("minecraft:pink_banner"), (byte) 16, () -> Registries.getBlock("minecraft:pink_banner")),

    GRAY_BANNER(NamespaceID.from("minecraft:gray_banner"), (byte) 16, () -> Registries.getBlock("minecraft:gray_banner")),

    LIGHT_GRAY_BANNER(NamespaceID.from("minecraft:light_gray_banner"), (byte) 16, () -> Registries.getBlock("minecraft:light_gray_banner")),

    CYAN_BANNER(NamespaceID.from("minecraft:cyan_banner"), (byte) 16, () -> Registries.getBlock("minecraft:cyan_banner")),

    PURPLE_BANNER(NamespaceID.from("minecraft:purple_banner"), (byte) 16, () -> Registries.getBlock("minecraft:purple_banner")),

    BLUE_BANNER(NamespaceID.from("minecraft:blue_banner"), (byte) 16, () -> Registries.getBlock("minecraft:blue_banner")),

    BROWN_BANNER(NamespaceID.from("minecraft:brown_banner"), (byte) 16, () -> Registries.getBlock("minecraft:brown_banner")),

    GREEN_BANNER(NamespaceID.from("minecraft:green_banner"), (byte) 16, () -> Registries.getBlock("minecraft:green_banner")),

    RED_BANNER(NamespaceID.from("minecraft:red_banner"), (byte) 16, () -> Registries.getBlock("minecraft:red_banner")),

    BLACK_BANNER(NamespaceID.from("minecraft:black_banner"), (byte) 16, () -> Registries.getBlock("minecraft:black_banner")),

    END_CRYSTAL(NamespaceID.from("minecraft:end_crystal"), (byte) 64, () -> null),

    CHORUS_FRUIT(NamespaceID.from("minecraft:chorus_fruit"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    POPPED_CHORUS_FRUIT(NamespaceID.from("minecraft:popped_chorus_fruit"), (byte) 64, () -> null),

    BEETROOT(NamespaceID.from("minecraft:beetroot"), (byte) 64, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    BEETROOT_SEEDS(NamespaceID.from("minecraft:beetroot_seeds"), (byte) 64, () -> Registries.getBlock("minecraft:beetroots")),

    BEETROOT_SOUP(NamespaceID.from("minecraft:beetroot_soup"), (byte) 1, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    DRAGON_BREATH(NamespaceID.from("minecraft:dragon_breath"), (byte) 64, () -> null),

    SPLASH_POTION(NamespaceID.from("minecraft:splash_potion"), (byte) 1, () -> null),

    SPECTRAL_ARROW(NamespaceID.from("minecraft:spectral_arrow"), (byte) 64, () -> null),

    TIPPED_ARROW(NamespaceID.from("minecraft:tipped_arrow"), (byte) 64, () -> null),

    LINGERING_POTION(NamespaceID.from("minecraft:lingering_potion"), (byte) 1, () -> null),

    SHIELD(NamespaceID.from("minecraft:shield"), (byte) 1, () -> null),

    ELYTRA(NamespaceID.from("minecraft:elytra"), (byte) 1, () -> null),

    SPRUCE_BOAT(NamespaceID.from("minecraft:spruce_boat"), (byte) 1, () -> null),

    BIRCH_BOAT(NamespaceID.from("minecraft:birch_boat"), (byte) 1, () -> null),

    JUNGLE_BOAT(NamespaceID.from("minecraft:jungle_boat"), (byte) 1, () -> null),

    ACACIA_BOAT(NamespaceID.from("minecraft:acacia_boat"), (byte) 1, () -> null),

    DARK_OAK_BOAT(NamespaceID.from("minecraft:dark_oak_boat"), (byte) 1, () -> null),

    TOTEM_OF_UNDYING(NamespaceID.from("minecraft:totem_of_undying"), (byte) 1, () -> null),

    SHULKER_SHELL(NamespaceID.from("minecraft:shulker_shell"), (byte) 64, () -> null),

    IRON_NUGGET(NamespaceID.from("minecraft:iron_nugget"), (byte) 64, () -> null),

    KNOWLEDGE_BOOK(NamespaceID.from("minecraft:knowledge_book"), (byte) 1, () -> null),

    DEBUG_STICK(NamespaceID.from("minecraft:debug_stick"), (byte) 1, () -> null),

    MUSIC_DISC_13(NamespaceID.from("minecraft:music_disc_13"), (byte) 1, () -> null),

    MUSIC_DISC_CAT(NamespaceID.from("minecraft:music_disc_cat"), (byte) 1, () -> null),

    MUSIC_DISC_BLOCKS(NamespaceID.from("minecraft:music_disc_blocks"), (byte) 1, () -> null),

    MUSIC_DISC_CHIRP(NamespaceID.from("minecraft:music_disc_chirp"), (byte) 1, () -> null),

    MUSIC_DISC_FAR(NamespaceID.from("minecraft:music_disc_far"), (byte) 1, () -> null),

    MUSIC_DISC_MALL(NamespaceID.from("minecraft:music_disc_mall"), (byte) 1, () -> null),

    MUSIC_DISC_MELLOHI(NamespaceID.from("minecraft:music_disc_mellohi"), (byte) 1, () -> null),

    MUSIC_DISC_STAL(NamespaceID.from("minecraft:music_disc_stal"), (byte) 1, () -> null),

    MUSIC_DISC_STRAD(NamespaceID.from("minecraft:music_disc_strad"), (byte) 1, () -> null),

    MUSIC_DISC_WARD(NamespaceID.from("minecraft:music_disc_ward"), (byte) 1, () -> null),

    MUSIC_DISC_11(NamespaceID.from("minecraft:music_disc_11"), (byte) 1, () -> null),

    MUSIC_DISC_WAIT(NamespaceID.from("minecraft:music_disc_wait"), (byte) 1, () -> null),

    MUSIC_DISC_PIGSTEP(NamespaceID.from("minecraft:music_disc_pigstep"), (byte) 1, () -> null),

    TRIDENT(NamespaceID.from("minecraft:trident"), (byte) 1, () -> null),

    PHANTOM_MEMBRANE(NamespaceID.from("minecraft:phantom_membrane"), (byte) 64, () -> null),

    NAUTILUS_SHELL(NamespaceID.from("minecraft:nautilus_shell"), (byte) 64, () -> null),

    HEART_OF_THE_SEA(NamespaceID.from("minecraft:heart_of_the_sea"), (byte) 64, () -> null),

    CROSSBOW(NamespaceID.from("minecraft:crossbow"), (byte) 1, () -> null),

    SUSPICIOUS_STEW(NamespaceID.from("minecraft:suspicious_stew"), (byte) 1, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    LOOM(NamespaceID.from("minecraft:loom"), (byte) 64, () -> Registries.getBlock("minecraft:loom")),

    FLOWER_BANNER_PATTERN(NamespaceID.from("minecraft:flower_banner_pattern"), (byte) 1, () -> null),

    CREEPER_BANNER_PATTERN(NamespaceID.from("minecraft:creeper_banner_pattern"), (byte) 1, () -> null),

    SKULL_BANNER_PATTERN(NamespaceID.from("minecraft:skull_banner_pattern"), (byte) 1, () -> null),

    MOJANG_BANNER_PATTERN(NamespaceID.from("minecraft:mojang_banner_pattern"), (byte) 1, () -> null),

    GLOBE_BANNER_PATTER(NamespaceID.from("minecraft:globe_banner_pattern"), (byte) 1, () -> null),

    PIGLIN_BANNER_PATTERN(NamespaceID.from("minecraft:piglin_banner_pattern"), (byte) 1, () -> null),

    COMPOSTER(NamespaceID.from("minecraft:composter"), (byte) 64, () -> Registries.getBlock("minecraft:composter")),

    BARREL(NamespaceID.from("minecraft:barrel"), (byte) 64, () -> Registries.getBlock("minecraft:barrel")),

    SMOKER(NamespaceID.from("minecraft:smoker"), (byte) 64, () -> Registries.getBlock("minecraft:smoker")),

    BLAST_FURNACE(NamespaceID.from("minecraft:blast_furnace"), (byte) 64, () -> Registries.getBlock("minecraft:blast_furnace")),

    CARTOGRAPHY_TABLE(NamespaceID.from("minecraft:cartography_table"), (byte) 64, () -> Registries.getBlock("minecraft:cartography_table")),

    FLETCHING_TABLE(NamespaceID.from("minecraft:fletching_table"), (byte) 64, () -> Registries.getBlock("minecraft:fletching_table")),

    GRINDSTONE(NamespaceID.from("minecraft:grindstone"), (byte) 64, () -> Registries.getBlock("minecraft:grindstone")),

    LECTERN(NamespaceID.from("minecraft:lectern"), (byte) 64, () -> Registries.getBlock("minecraft:lectern")),

    SMITHING_TABLE(NamespaceID.from("minecraft:smithing_table"), (byte) 64, () -> Registries.getBlock("minecraft:smithing_table")),

    STONECUTTER(NamespaceID.from("minecraft:stonecutter"), (byte) 64, () -> Registries.getBlock("minecraft:stonecutter")),

    BELL(NamespaceID.from("minecraft:bell"), (byte) 64, () -> Registries.getBlock("minecraft:bell")),

    LANTERN(NamespaceID.from("minecraft:lantern"), (byte) 64, () -> Registries.getBlock("minecraft:lantern")),

    SOUL_LANTERN(NamespaceID.from("minecraft:soul_lantern"), (byte) 64, () -> Registries.getBlock("minecraft:soul_lantern")),

    SWEET_BERRIES(NamespaceID.from("minecraft:sweet_berries"), (byte) 64, () -> Registries.getBlock("minecraft:sweet_berry_bush")) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    CAMPFIRE(NamespaceID.from("minecraft:campfire"), (byte) 64, () -> Registries.getBlock("minecraft:campfire")),

    SOUL_CAMPFIRE(NamespaceID.from("minecraft:soul_campfire"), (byte) 64, () -> Registries.getBlock("minecraft:soul_campfire")),

    SHROOMLIGHT(NamespaceID.from("minecraft:shroomlight"), (byte) 64, () -> Registries.getBlock("minecraft:shroomlight")),

    HONEYCOMB(NamespaceID.from("minecraft:honeycomb"), (byte) 64, () -> null),

    BEE_NEST(NamespaceID.from("minecraft:bee_nest"), (byte) 64, () -> Registries.getBlock("minecraft:bee_nest")),

    BEEHIVE(NamespaceID.from("minecraft:beehive"), (byte) 64, () -> Registries.getBlock("minecraft:beehive")),

    HONEY_BOTTLE(NamespaceID.from("minecraft:honey_bottle"), (byte) 16, () -> null) {
        @Override
        public boolean isFood() {
            return true;
        }
    },

    HONEY_BLOCK(NamespaceID.from("minecraft:honey_block"), (byte) 64, () -> Registries.getBlock("minecraft:honey_block")),

    HONEYCOMB_BLOCK(NamespaceID.from("minecraft:honeycomb_block"), (byte) 64, () -> Registries.getBlock("minecraft:honeycomb_block")),

    LODESTONE(NamespaceID.from("minecraft:lodestone"), (byte) 64, () -> Registries.getBlock("minecraft:lodestone")),

    NETHERITE_BLOCK(NamespaceID.from("minecraft:netherite_block"), (byte) 64, () -> Registries.getBlock("minecraft:netherite_block")),

    ANCIENT_DEBRIS(NamespaceID.from("minecraft:ancient_debris"), (byte) 64, () -> Registries.getBlock("minecraft:ancient_debris")),

    TARGET(NamespaceID.from("minecraft:target"), (byte) 64, () -> Registries.getBlock("minecraft:target")),

    CRYING_OBSIDIAN(NamespaceID.from("minecraft:crying_obsidian"), (byte) 64, () -> Registries.getBlock("minecraft:crying_obsidian")),

    BLACKSTONE(NamespaceID.from("minecraft:blackstone"), (byte) 64, () -> Registries.getBlock("minecraft:blackstone")),

    BLACKSTONE_SLAB(NamespaceID.from("minecraft:blackstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:blackstone_slab")),

    BLACKSTONE_STAIRS(NamespaceID.from("minecraft:blackstone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:blackstone_stairs")),

    GILDED_BLACKSTONE(NamespaceID.from("minecraft:gilded_blackstone"), (byte) 64, () -> Registries.getBlock("minecraft:gilded_blackstone")),

    POLISHED_BLACKSTONE(NamespaceID.from("minecraft:polished_blackstone"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone")),

    POLISHED_BLACKSTONE_SLAB(NamespaceID.from("minecraft:polished_blackstone_slab"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_slab")),

    POLISHED_BLACKSTONE_STAIRS(NamespaceID.from("minecraft:polished_blackstone_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_stairs")),

    CHISELED_POLISHED_BLACKSTONE(NamespaceID.from("minecraft:chiseled_polished_blackstone"), (byte) 64, () -> Registries.getBlock("minecraft:chiseled_polished_blackstone")),

    POLISHED_BLACKSTONE_BRICKS(NamespaceID.from("minecraft:polished_blackstone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_bricks")),

    POLISHED_BLACKSTONE_BRICK_SLAB(NamespaceID.from("minecraft:polished_blackstone_brick_slab"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_brick_slab")),

    POLISHED_BLACKSTONE_BRICK_STAIRS(NamespaceID.from("minecraft:polished_blackstone_brick_stairs"), (byte) 64, () -> Registries.getBlock("minecraft:polished_blackstone_brick_stairs")),

    CRACKED_POLISHED_BLACKSTONE_BRICKS(NamespaceID.from("minecraft:cracked_polished_blackstone_bricks"), (byte) 64, () -> Registries.getBlock("minecraft:cracked_polished_blackstone_bricks")),

    RESPAWN_ANCHOR(NamespaceID.from("minecraft:respawn_anchor"), (byte) 64, () -> Registries.getBlock("minecraft:respawn_anchor"));

    private static final Material[] VALUES = values();

    @NotNull
    private final NamespaceID id;

    private final byte maxDefaultStackSize;

    private final Supplier<Block> correspondingBlockSupplier;

    Material(@NotNull NamespaceID id, byte maxDefaultStackSize,
            @NotNull Supplier<Block> correspondingBlockSupplier) {
        this.id = id;
        this.maxDefaultStackSize = maxDefaultStackSize;
        this.correspondingBlockSupplier = correspondingBlockSupplier;
        Registries.materials.put(id, this);
    }

    @Override
    @NotNull
    public Key key() {
        return this.id;
    }

    public short getId() {
        return (short) ordinal();
    }

    @NotNull
    public NamespaceID getNamespaceID() {
        return this.id;
    }

    @NotNull
    public String getName() {
        return this.id.asString();
    }

    public byte getMaxDefaultStackSize() {
        return this.maxDefaultStackSize;
    }

    @Nullable
    public static Material fromId(short id) {
        if(id >= 0 && id < VALUES.length) {
            return VALUES[id];
        }
        return null;
    }

    public boolean isFood() {
        return false;
    }

    public boolean hasState() {
        if (this == BOW || this == TRIDENT || this == CROSSBOW || this == SHIELD) {
            return true;
        } else {
            return isFood();
        }
    }

    public boolean isBlock() {
        return this.correspondingBlockSupplier.get() != null && this.correspondingBlockSupplier.get() != Block.AIR;
    }

    public boolean isArmor() {
        return false;
    }

    public boolean isHelmet() {
        return false;
    }

    public boolean isChestplate() {
        return false;
    }

    public boolean isLeggings() {
        return false;
    }

    public boolean isBoots() {
        return false;
    }

    @Nullable
    public Block getBlock() {
        return this.correspondingBlockSupplier.get();
    }

    @NotNull
    @Override
    public String toString() {
        return "[" + this.id + "]";
    }
}
