package net.minestom.server.particle;

import net.kyori.adventure.key.Key;
import net.kyori.adventure.key.Keyed;
import net.minestom.server.registry.Registries;
import net.minestom.server.utils.NamespaceID;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * AUTOGENERATED by ParticleGenerator
 */
public enum Particle implements Keyed {
    AMBIENT_ENTITY_EFFECT(NamespaceID.from("minecraft:ambient_entity_effect")),

    ANGRY_VILLAGER(NamespaceID.from("minecraft:angry_villager")),

    BARRIER(NamespaceID.from("minecraft:barrier")),

    BLOCK(NamespaceID.from("minecraft:block")),

    BUBBLE(NamespaceID.from("minecraft:bubble")),

    CLOUD(NamespaceID.from("minecraft:cloud")),

    CRIT(NamespaceID.from("minecraft:crit")),

    DAMAGE_INDICATOR(NamespaceID.from("minecraft:damage_indicator")),

    DRAGON_BREATH(NamespaceID.from("minecraft:dragon_breath")),

    DRIPPING_LAVA(NamespaceID.from("minecraft:dripping_lava")),

    FALLING_LAVA(NamespaceID.from("minecraft:falling_lava")),

    LANDING_LAVA(NamespaceID.from("minecraft:landing_lava")),

    DRIPPING_WATER(NamespaceID.from("minecraft:dripping_water")),

    FALLING_WATER(NamespaceID.from("minecraft:falling_water")),

    DUST(NamespaceID.from("minecraft:dust")),

    EFFECT(NamespaceID.from("minecraft:effect")),

    ELDER_GUARDIAN(NamespaceID.from("minecraft:elder_guardian")),

    ENCHANTED_HIT(NamespaceID.from("minecraft:enchanted_hit")),

    ENCHANT(NamespaceID.from("minecraft:enchant")),

    END_ROD(NamespaceID.from("minecraft:end_rod")),

    ENTITY_EFFECT(NamespaceID.from("minecraft:entity_effect")),

    EXPLOSION_EMITTER(NamespaceID.from("minecraft:explosion_emitter")),

    EXPLOSION(NamespaceID.from("minecraft:explosion")),

    FALLING_DUST(NamespaceID.from("minecraft:falling_dust")),

    FIREWORK(NamespaceID.from("minecraft:firework")),

    FISHING(NamespaceID.from("minecraft:fishing")),

    FLAME(NamespaceID.from("minecraft:flame")),

    SOUL_FIRE_FLAME(NamespaceID.from("minecraft:soul_fire_flame")),

    SOUL(NamespaceID.from("minecraft:soul")),

    FLASH(NamespaceID.from("minecraft:flash")),

    HAPPY_VILLAGER(NamespaceID.from("minecraft:happy_villager")),

    COMPOSTER(NamespaceID.from("minecraft:composter")),

    HEART(NamespaceID.from("minecraft:heart")),

    INSTANT_EFFECT(NamespaceID.from("minecraft:instant_effect")),

    ITEM(NamespaceID.from("minecraft:item")),

    ITEM_SLIME(NamespaceID.from("minecraft:item_slime")),

    ITEM_SNOWBALL(NamespaceID.from("minecraft:item_snowball")),

    LARGE_SMOKE(NamespaceID.from("minecraft:large_smoke")),

    LAVA(NamespaceID.from("minecraft:lava")),

    MYCELIUM(NamespaceID.from("minecraft:mycelium")),

    NOTE(NamespaceID.from("minecraft:note")),

    POOF(NamespaceID.from("minecraft:poof")),

    PORTAL(NamespaceID.from("minecraft:portal")),

    RAIN(NamespaceID.from("minecraft:rain")),

    SMOKE(NamespaceID.from("minecraft:smoke")),

    SNEEZE(NamespaceID.from("minecraft:sneeze")),

    SPIT(NamespaceID.from("minecraft:spit")),

    SQUID_INK(NamespaceID.from("minecraft:squid_ink")),

    SWEEP_ATTACK(NamespaceID.from("minecraft:sweep_attack")),

    TOTEM_OF_UNDYING(NamespaceID.from("minecraft:totem_of_undying")),

    UNDERWATER(NamespaceID.from("minecraft:underwater")),

    SPLASH(NamespaceID.from("minecraft:splash")),

    WITCH(NamespaceID.from("minecraft:witch")),

    BUBBLE_POP(NamespaceID.from("minecraft:bubble_pop")),

    CURRENT_DOWN(NamespaceID.from("minecraft:current_down")),

    BUBBLE_COLUMN_UP(NamespaceID.from("minecraft:bubble_column_up")),

    NAUTILUS(NamespaceID.from("minecraft:nautilus")),

    DOLPHIN(NamespaceID.from("minecraft:dolphin")),

    CAMPFIRE_COSY_SMOKE(NamespaceID.from("minecraft:campfire_cosy_smoke")),

    CAMPFIRE_SIGNAL_SMOKE(NamespaceID.from("minecraft:campfire_signal_smoke")),

    DRIPPING_HONEY(NamespaceID.from("minecraft:dripping_honey")),

    FALLING_HONEY(NamespaceID.from("minecraft:falling_honey")),

    LANDING_HONEY(NamespaceID.from("minecraft:landing_honey")),

    FALLING_NECTAR(NamespaceID.from("minecraft:falling_nectar")),

    ASH(NamespaceID.from("minecraft:ash")),

    CRIMSON_SPORE(NamespaceID.from("minecraft:crimson_spore")),

    WARPED_SPORE(NamespaceID.from("minecraft:warped_spore")),

    DRIPPING_OBSIDIAN_TEAR(NamespaceID.from("minecraft:dripping_obsidian_tear")),

    FALLING_OBSIDIAN_TEAR(NamespaceID.from("minecraft:falling_obsidian_tear")),

    LANDING_OBSIDIAN_TEAR(NamespaceID.from("minecraft:landing_obsidian_tear")),

    REVERSE_PORTAL(NamespaceID.from("minecraft:reverse_portal")),

    WHITE_ASH(NamespaceID.from("minecraft:white_ash"));

    private static final Particle[] VALUES = values();

    @NotNull
    private final NamespaceID id;

    Particle(@NotNull NamespaceID id) {
        this.id = id;
        Registries.particles.put(id, this);
    }

    @Override
    @NotNull
    public Key key() {
        return this.id;
    }

    public short getId() {
        return (short) ordinal();
    }

    @NotNull
    public NamespaceID getNamespaceID() {
        return this.id;
    }

    @Nullable
    public static Particle fromId(short id) {
        if(id >= 0 && id < VALUES.length) {
            return VALUES[id];
        }
        return null;
    }

    @NotNull
    @Override
    public String toString() {
        return "[" + this.id + "]";
    }
}
